# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing_extensions import Annotated
from ibm_gdsc_sdk_software.models.qspmpluginmanagerv3_plugin_rq import Qspmpluginmanagerv3PluginRQ
from ibm_gdsc_sdk_software.models.qspmpluginmanagerv3_plugin_rs import Qspmpluginmanagerv3PluginRS
from ibm_gdsc_sdk_software.models.qspmpluginmanagerv3_policy_plugin_rq import Qspmpluginmanagerv3PolicyPluginRQ
from ibm_gdsc_sdk_software.models.qspmpluginmanagerv3_policy_plugin_rs import Qspmpluginmanagerv3PolicyPluginRS

from ibm_gdsc_sdk_software.api_client import ApiClient, RequestSerialized
from ibm_gdsc_sdk_software.api_response import ApiResponse
from ibm_gdsc_sdk_software.rest import RESTResponseType


class QSPluginManagerApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def q_s_plugin_manager_invoke_app_prov(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Qspmpluginmanagerv3PluginRS:
        """Summary: Invoke only application provisioning data plugin Description:Parses app input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_app_prov_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def q_s_plugin_manager_invoke_app_prov_with_http_info(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Qspmpluginmanagerv3PluginRS]:
        """Summary: Invoke only application provisioning data plugin Description:Parses app input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_app_prov_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def q_s_plugin_manager_invoke_app_prov_without_preload_content(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Summary: Invoke only application provisioning data plugin Description:Parses app input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_app_prov_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _q_s_plugin_manager_invoke_app_prov_serialize(
        self,
        plugin_id,
        qspmpluginmanagerv3_plugin_rq,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if plugin_id is not None:
            _path_params['plugin_id'] = plugin_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if qspmpluginmanagerv3_plugin_rq is not None:
            _body_params = qspmpluginmanagerv3_plugin_rq


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'BasicAuth', 
            'ApiKeyAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v3/plugins/{plugin_id}/application',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def q_s_plugin_manager_invoke_explorer_v1(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Qspmpluginmanagerv3PluginRS:
        """Summary: Invoke only explorer inventory data plugin Description:Parses explorer input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_explorer_v1_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def q_s_plugin_manager_invoke_explorer_v1_with_http_info(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Qspmpluginmanagerv3PluginRS]:
        """Summary: Invoke only explorer inventory data plugin Description:Parses explorer input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_explorer_v1_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def q_s_plugin_manager_invoke_explorer_v1_without_preload_content(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Summary: Invoke only explorer inventory data plugin Description:Parses explorer input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_explorer_v1_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _q_s_plugin_manager_invoke_explorer_v1_serialize(
        self,
        plugin_id,
        qspmpluginmanagerv3_plugin_rq,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if plugin_id is not None:
            _path_params['plugin_id'] = plugin_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if qspmpluginmanagerv3_plugin_rq is not None:
            _body_params = qspmpluginmanagerv3_plugin_rq


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'BasicAuth', 
            'ApiKeyAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v3/plugins/{plugin_id}/explorer',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def q_s_plugin_manager_invoke_explorer_v2(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Qspmpluginmanagerv3PluginRS:
        """Summary: Invoke only explorer analytics data plugin Description:Parses explorer input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_explorer_v2_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def q_s_plugin_manager_invoke_explorer_v2_with_http_info(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Qspmpluginmanagerv3PluginRS]:
        """Summary: Invoke only explorer analytics data plugin Description:Parses explorer input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_explorer_v2_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def q_s_plugin_manager_invoke_explorer_v2_without_preload_content(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Summary: Invoke only explorer analytics data plugin Description:Parses explorer input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_explorer_v2_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _q_s_plugin_manager_invoke_explorer_v2_serialize(
        self,
        plugin_id,
        qspmpluginmanagerv3_plugin_rq,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if plugin_id is not None:
            _path_params['plugin_id'] = plugin_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if qspmpluginmanagerv3_plugin_rq is not None:
            _body_params = qspmpluginmanagerv3_plugin_rq


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'BasicAuth', 
            'ApiKeyAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v3/plugins/{plugin_id}/explorer/analytics',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def q_s_plugin_manager_invoke_plugin(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Qspmpluginmanagerv3PluginRS:
        """Summary: Invoke consolidated or only network data plugin Description:Parses input files and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_plugin_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def q_s_plugin_manager_invoke_plugin_with_http_info(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Qspmpluginmanagerv3PluginRS]:
        """Summary: Invoke consolidated or only network data plugin Description:Parses input files and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_plugin_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def q_s_plugin_manager_invoke_plugin_without_preload_content(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Summary: Invoke consolidated or only network data plugin Description:Parses input files and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_plugin_rq: (required)
        :type qspmpluginmanagerv3_plugin_rq: Qspmpluginmanagerv3PluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_plugin_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_plugin_rq=qspmpluginmanagerv3_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _q_s_plugin_manager_invoke_plugin_serialize(
        self,
        plugin_id,
        qspmpluginmanagerv3_plugin_rq,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if plugin_id is not None:
            _path_params['plugin_id'] = plugin_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if qspmpluginmanagerv3_plugin_rq is not None:
            _body_params = qspmpluginmanagerv3_plugin_rq


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'BasicAuth', 
            'ApiKeyAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v3/plugins/{plugin_id}/network',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def q_s_plugin_manager_invoke_policy(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_policy_plugin_rq: Qspmpluginmanagerv3PolicyPluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Qspmpluginmanagerv3PolicyPluginRS:
        """Summary: Invoke only policy data plugin Description:Parses policy input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_policy_plugin_rq: (required)
        :type qspmpluginmanagerv3_policy_plugin_rq: Qspmpluginmanagerv3PolicyPluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_policy_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_policy_plugin_rq=qspmpluginmanagerv3_policy_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PolicyPluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def q_s_plugin_manager_invoke_policy_with_http_info(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_policy_plugin_rq: Qspmpluginmanagerv3PolicyPluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Qspmpluginmanagerv3PolicyPluginRS]:
        """Summary: Invoke only policy data plugin Description:Parses policy input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_policy_plugin_rq: (required)
        :type qspmpluginmanagerv3_policy_plugin_rq: Qspmpluginmanagerv3PolicyPluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_policy_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_policy_plugin_rq=qspmpluginmanagerv3_policy_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PolicyPluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def q_s_plugin_manager_invoke_policy_without_preload_content(
        self,
        plugin_id: Annotated[StrictStr, Field(description="Unique identifier for the plugin")],
        qspmpluginmanagerv3_policy_plugin_rq: Qspmpluginmanagerv3PolicyPluginRQ,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Summary: Invoke only policy data plugin Description:Parses policy input file and triggers dataload


        :param plugin_id: Unique identifier for the plugin (required)
        :type plugin_id: str
        :param qspmpluginmanagerv3_policy_plugin_rq: (required)
        :type qspmpluginmanagerv3_policy_plugin_rq: Qspmpluginmanagerv3PolicyPluginRQ
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._q_s_plugin_manager_invoke_policy_serialize(
            plugin_id=plugin_id,
            qspmpluginmanagerv3_policy_plugin_rq=qspmpluginmanagerv3_policy_plugin_rq,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Qspmpluginmanagerv3PolicyPluginRS",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _q_s_plugin_manager_invoke_policy_serialize(
        self,
        plugin_id,
        qspmpluginmanagerv3_policy_plugin_rq,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if plugin_id is not None:
            _path_params['plugin_id'] = plugin_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if qspmpluginmanagerv3_policy_plugin_rq is not None:
            _body_params = qspmpluginmanagerv3_policy_plugin_rq


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'BasicAuth', 
            'ApiKeyAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v3/plugins/{plugin_id}/policy',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


