# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.assetsv3_connection_edge import Assetsv3ConnectionEdge
from ibm_gdsc_sdk_software.models.assetsv3_custom_property import Assetsv3CustomProperty
from ibm_gdsc_sdk_software.models.assetsv3_level import Assetsv3Level
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3ApplicationVertex(BaseModel):
    """
    Assetsv3ApplicationVertex
    """ # noqa: E501
    app_id: Optional[StrictStr] = None
    application_database: Optional[List[Assetsv3ConnectionEdge]] = None
    application_endpoint: Optional[List[Assetsv3ConnectionEdge]] = None
    application_host: Optional[List[Assetsv3ConnectionEdge]] = None
    application_ip: Optional[List[Assetsv3ConnectionEdge]] = None
    application_name: Optional[StrictStr] = None
    application_storage: Optional[List[Assetsv3ConnectionEdge]] = None
    application_sub_type: Optional[StrictStr] = None
    application_subscription: Optional[List[Assetsv3ConnectionEdge]] = None
    application_type: Optional[StrictStr] = None
    category: Optional[StrictStr] = None
    criticality: Optional[Assetsv3Level] = None
    extended_properties: Optional[List[Assetsv3CustomProperty]] = None
    last_used: Optional[datetime] = None
    owner: Optional[List[StrictStr]] = None
    parent_application: Optional[StrictStr] = None
    resolution_key: Optional[StrictStr] = None
    risk_level: Optional[Assetsv3Level] = None
    service_type: Optional[StrictStr] = None
    version: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["app_id", "application_database", "application_endpoint", "application_host", "application_ip", "application_name", "application_storage", "application_sub_type", "application_subscription", "application_type", "category", "criticality", "extended_properties", "last_used", "owner", "parent_application", "resolution_key", "risk_level", "service_type", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3ApplicationVertex from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in application_database (list)
        _items = []
        if self.application_database:
            for _item in self.application_database:
                if _item:
                    _items.append(_item.to_dict())
            _dict['application_database'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in application_endpoint (list)
        _items = []
        if self.application_endpoint:
            for _item in self.application_endpoint:
                if _item:
                    _items.append(_item.to_dict())
            _dict['application_endpoint'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in application_host (list)
        _items = []
        if self.application_host:
            for _item in self.application_host:
                if _item:
                    _items.append(_item.to_dict())
            _dict['application_host'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in application_ip (list)
        _items = []
        if self.application_ip:
            for _item in self.application_ip:
                if _item:
                    _items.append(_item.to_dict())
            _dict['application_ip'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in application_storage (list)
        _items = []
        if self.application_storage:
            for _item in self.application_storage:
                if _item:
                    _items.append(_item.to_dict())
            _dict['application_storage'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in application_subscription (list)
        _items = []
        if self.application_subscription:
            for _item in self.application_subscription:
                if _item:
                    _items.append(_item.to_dict())
            _dict['application_subscription'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in extended_properties (list)
        _items = []
        if self.extended_properties:
            for _item in self.extended_properties:
                if _item:
                    _items.append(_item.to_dict())
            _dict['extended_properties'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3ApplicationVertex from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "app_id": obj.get("app_id"),
            "application_database": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["application_database"]] if obj.get("application_database") is not None else None,
            "application_endpoint": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["application_endpoint"]] if obj.get("application_endpoint") is not None else None,
            "application_host": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["application_host"]] if obj.get("application_host") is not None else None,
            "application_ip": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["application_ip"]] if obj.get("application_ip") is not None else None,
            "application_name": obj.get("application_name"),
            "application_storage": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["application_storage"]] if obj.get("application_storage") is not None else None,
            "application_sub_type": obj.get("application_sub_type"),
            "application_subscription": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["application_subscription"]] if obj.get("application_subscription") is not None else None,
            "application_type": obj.get("application_type"),
            "category": obj.get("category"),
            "criticality": obj.get("criticality"),
            "extended_properties": [Assetsv3CustomProperty.from_dict(_item) for _item in obj["extended_properties"]] if obj.get("extended_properties") is not None else None,
            "last_used": obj.get("last_used"),
            "owner": obj.get("owner"),
            "parent_application": obj.get("parent_application"),
            "resolution_key": obj.get("resolution_key"),
            "risk_level": obj.get("risk_level"),
            "service_type": obj.get("service_type"),
            "version": obj.get("version")
        })
        return _obj


