# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.assetsv3_asset_view import Assetsv3AssetView
from ibm_gdsc_sdk_software.models.assetsv3_filter_catagory import Assetsv3FilterCatagory
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3FetchAssetListRequest(BaseModel):
    """
    Assetsv3FetchAssetListRequest
    """ # noqa: E501
    columns: Optional[List[StrictStr]] = None
    filter: Optional[List[Assetsv3FilterCatagory]] = None
    page_number: Optional[StrictInt] = None
    page_size: Optional[StrictInt] = None
    parent_id: Optional[StrictStr] = None
    search_key: Optional[StrictStr] = None
    sort: Optional[StrictStr] = None
    sort_by: Optional[StrictStr] = None
    view_type: Optional[Assetsv3AssetView] = None
    __properties: ClassVar[List[str]] = ["columns", "filter", "page_number", "page_size", "parent_id", "search_key", "sort", "sort_by", "view_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3FetchAssetListRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in filter (list)
        _items = []
        if self.filter:
            for _item in self.filter:
                if _item:
                    _items.append(_item.to_dict())
            _dict['filter'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3FetchAssetListRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "columns": obj.get("columns"),
            "filter": [Assetsv3FilterCatagory.from_dict(_item) for _item in obj["filter"]] if obj.get("filter") is not None else None,
            "page_number": obj.get("page_number"),
            "page_size": obj.get("page_size"),
            "parent_id": obj.get("parent_id"),
            "search_key": obj.get("search_key"),
            "sort": obj.get("sort"),
            "sort_by": obj.get("sort_by"),
            "view_type": obj.get("view_type")
        })
        return _obj


