# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.assetsv3_filter_catagory import Assetsv3FilterCatagory
from ibm_gdsc_sdk_software.models.assetsv3_table_column import Assetsv3TableColumn
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3FilterTemplate(BaseModel):
    """
    FilterTemplate - Filter Template structure.
    """ # noqa: E501
    colummns_list: Optional[List[Assetsv3TableColumn]] = None
    count: Optional[StrictStr] = None
    created_by: Optional[StrictStr] = None
    created_date: Optional[StrictStr] = None
    dashboard_template: Optional[StrictBool] = None
    description: Optional[StrictStr] = None
    id: Optional[StrictStr] = None
    selected_filters: Optional[List[Assetsv3FilterCatagory]] = None
    template_id: Optional[StrictStr] = None
    title: Optional[StrictStr] = None
    updated_date: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["colummns_list", "count", "created_by", "created_date", "dashboard_template", "description", "id", "selected_filters", "template_id", "title", "updated_date"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3FilterTemplate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in colummns_list (list)
        _items = []
        if self.colummns_list:
            for _item in self.colummns_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['colummns_list'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in selected_filters (list)
        _items = []
        if self.selected_filters:
            for _item in self.selected_filters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['selected_filters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3FilterTemplate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "colummns_list": [Assetsv3TableColumn.from_dict(_item) for _item in obj["colummns_list"]] if obj.get("colummns_list") is not None else None,
            "count": obj.get("count"),
            "created_by": obj.get("created_by"),
            "created_date": obj.get("created_date"),
            "dashboard_template": obj.get("dashboard_template"),
            "description": obj.get("description"),
            "id": obj.get("id"),
            "selected_filters": [Assetsv3FilterCatagory.from_dict(_item) for _item in obj["selected_filters"]] if obj.get("selected_filters") is not None else None,
            "template_id": obj.get("template_id"),
            "title": obj.get("title"),
            "updated_date": obj.get("updated_date")
        })
        return _obj


