# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.assetsv3_assigned_tags import Assetsv3AssignedTags
from ibm_gdsc_sdk_software.models.assetsv3_suggestions_tags import Assetsv3SuggestionsTags
from ibm_gdsc_sdk_software.models.assetsv3_unassigned_tags import Assetsv3UnassignedTags
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3ListTagsResponse(BaseModel):
    """
    Response for listing tags.
    """ # noqa: E501
    assigned: Optional[List[Assetsv3AssignedTags]] = None
    suggestions: Optional[List[Assetsv3SuggestionsTags]] = None
    unassigned: Optional[List[Assetsv3UnassignedTags]] = None
    __properties: ClassVar[List[str]] = ["assigned", "suggestions", "unassigned"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3ListTagsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in assigned (list)
        _items = []
        if self.assigned:
            for _item in self.assigned:
                if _item:
                    _items.append(_item.to_dict())
            _dict['assigned'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in suggestions (list)
        _items = []
        if self.suggestions:
            for _item in self.suggestions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['suggestions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in unassigned (list)
        _items = []
        if self.unassigned:
            for _item in self.unassigned:
                if _item:
                    _items.append(_item.to_dict())
            _dict['unassigned'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3ListTagsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assigned": [Assetsv3AssignedTags.from_dict(_item) for _item in obj["assigned"]] if obj.get("assigned") is not None else None,
            "suggestions": [Assetsv3SuggestionsTags.from_dict(_item) for _item in obj["suggestions"]] if obj.get("suggestions") is not None else None,
            "unassigned": [Assetsv3UnassignedTags.from_dict(_item) for _item in obj["unassigned"]] if obj.get("unassigned") is not None else None
        })
        return _obj


