# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3Policy(BaseModel):
    """
    Base Policy object which is used in create and list APIs.
    """ # noqa: E501
    activation_status: Optional[StrictInt] = Field(default=None, description="Policy Activation Status.")
    installed_flag: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether policy is installed or not.")
    installed_timestamp: Optional[StrictStr] = None
    is_delete: Optional[StrictInt] = Field(default=None, description="Policy isDelete.")
    last_edited_timestamp: Optional[StrictStr] = None
    no_of_rules: Optional[StrictInt] = Field(default=None, description="No. of rules associated with policy.")
    policy_id: Optional[StrictStr] = Field(default=None, description="Policy ID.")
    policy_name: Optional[StrictStr] = Field(default=None, description="Policy Name.")
    policy_sequence: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["activation_status", "installed_flag", "installed_timestamp", "is_delete", "last_edited_timestamp", "no_of_rules", "policy_id", "policy_name", "policy_sequence"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3Policy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3Policy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activation_status": obj.get("activation_status"),
            "installed_flag": obj.get("installed_flag"),
            "installed_timestamp": obj.get("installed_timestamp"),
            "is_delete": obj.get("is_delete"),
            "last_edited_timestamp": obj.get("last_edited_timestamp"),
            "no_of_rules": obj.get("no_of_rules"),
            "policy_id": obj.get("policy_id"),
            "policy_name": obj.get("policy_name"),
            "policy_sequence": obj.get("policy_sequence")
        })
        return _obj


