# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.assetsv3_connection_edge import Assetsv3ConnectionEdge
from ibm_gdsc_sdk_software.models.assetsv3_custom_property import Assetsv3CustomProperty
from ibm_gdsc_sdk_software.models.assetsv3_level import Assetsv3Level
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3StorageVertex(BaseModel):
    """
    Assetsv3StorageVertex
    """ # noqa: E501
    city: Optional[StrictStr] = None
    country: Optional[StrictStr] = None
    criticality: Optional[Assetsv3Level] = None
    data_center: Optional[StrictStr] = None
    dns: Optional[StrictStr] = None
    extended_properties: Optional[List[Assetsv3CustomProperty]] = None
    folder_path: Optional[StrictStr] = None
    owner: Optional[List[StrictStr]] = None
    region: Optional[StrictStr] = None
    resolution_key: Optional[StrictStr] = None
    risk_level: Optional[Assetsv3Level] = None
    size: Optional[StrictStr] = None
    state: Optional[StrictStr] = None
    storage_account: Optional[List[Assetsv3ConnectionEdge]] = None
    storage_host: Optional[List[Assetsv3ConnectionEdge]] = None
    storage_id: Optional[StrictStr] = None
    storage_ip: Optional[List[Assetsv3ConnectionEdge]] = None
    storage_name: Optional[StrictStr] = None
    storage_resources: Optional[List[Assetsv3ConnectionEdge]] = None
    storage_sub_type: Optional[StrictStr] = None
    storage_subscription: Optional[List[Assetsv3ConnectionEdge]] = None
    storage_type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["city", "country", "criticality", "data_center", "dns", "extended_properties", "folder_path", "owner", "region", "resolution_key", "risk_level", "size", "state", "storage_account", "storage_host", "storage_id", "storage_ip", "storage_name", "storage_resources", "storage_sub_type", "storage_subscription", "storage_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3StorageVertex from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in extended_properties (list)
        _items = []
        if self.extended_properties:
            for _item in self.extended_properties:
                if _item:
                    _items.append(_item.to_dict())
            _dict['extended_properties'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in storage_account (list)
        _items = []
        if self.storage_account:
            for _item in self.storage_account:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storage_account'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in storage_host (list)
        _items = []
        if self.storage_host:
            for _item in self.storage_host:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storage_host'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in storage_ip (list)
        _items = []
        if self.storage_ip:
            for _item in self.storage_ip:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storage_ip'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in storage_resources (list)
        _items = []
        if self.storage_resources:
            for _item in self.storage_resources:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storage_resources'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in storage_subscription (list)
        _items = []
        if self.storage_subscription:
            for _item in self.storage_subscription:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storage_subscription'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3StorageVertex from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "city": obj.get("city"),
            "country": obj.get("country"),
            "criticality": obj.get("criticality"),
            "data_center": obj.get("data_center"),
            "dns": obj.get("dns"),
            "extended_properties": [Assetsv3CustomProperty.from_dict(_item) for _item in obj["extended_properties"]] if obj.get("extended_properties") is not None else None,
            "folder_path": obj.get("folder_path"),
            "owner": obj.get("owner"),
            "region": obj.get("region"),
            "resolution_key": obj.get("resolution_key"),
            "risk_level": obj.get("risk_level"),
            "size": obj.get("size"),
            "state": obj.get("state"),
            "storage_account": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["storage_account"]] if obj.get("storage_account") is not None else None,
            "storage_host": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["storage_host"]] if obj.get("storage_host") is not None else None,
            "storage_id": obj.get("storage_id"),
            "storage_ip": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["storage_ip"]] if obj.get("storage_ip") is not None else None,
            "storage_name": obj.get("storage_name"),
            "storage_resources": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["storage_resources"]] if obj.get("storage_resources") is not None else None,
            "storage_sub_type": obj.get("storage_sub_type"),
            "storage_subscription": [Assetsv3ConnectionEdge.from_dict(_item) for _item in obj["storage_subscription"]] if obj.get("storage_subscription") is not None else None,
            "storage_type": obj.get("storage_type")
        })
        return _obj


