# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3Tag(BaseModel):
    """
    Assetsv3Tag
    """ # noqa: E501
    creation_time: Optional[datetime] = None
    creation_time_utc: Optional[datetime] = None
    description: Optional[StrictStr] = Field(default=None, description="Description of Tag concept.")
    domain_id: Optional[StrictStr] = Field(default=None, description="Id of  Domain of the tag concept.")
    id: Optional[StrictStr] = Field(default=None, description="id of  concept.")
    is_delete: Optional[StrictBool] = None
    name: Optional[StrictStr] = Field(default=None, description="Name of Tag concept.")
    properties: Optional[StrictStr] = None
    source: Optional[StrictStr] = None
    updated_time: Optional[datetime] = None
    utc_offset: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["creation_time", "creation_time_utc", "description", "domain_id", "id", "is_delete", "name", "properties", "source", "updated_time", "utc_offset"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3Tag from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3Tag from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "creation_time": obj.get("creation_time"),
            "creation_time_utc": obj.get("creation_time_utc"),
            "description": obj.get("description"),
            "domain_id": obj.get("domain_id"),
            "id": obj.get("id"),
            "is_delete": obj.get("is_delete"),
            "name": obj.get("name"),
            "properties": obj.get("properties"),
            "source": obj.get("source"),
            "updated_time": obj.get("updated_time"),
            "utc_offset": obj.get("utc_offset")
        })
        return _obj


