# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.assetsv3_tag import Assetsv3Tag
from typing import Optional, Set
from typing_extensions import Self

class Assetsv3TagCategory(BaseModel):
    """
    Base tag domain object which is used in get and list APIs.
    """ # noqa: E501
    creation_time: Optional[datetime] = None
    creation_time_utc: Optional[datetime] = None
    description: Optional[StrictStr] = Field(default=None, description="Description of Tag Domain.")
    grouper: Optional[StrictStr] = None
    id: Optional[StrictStr] = Field(default=None, description="id of  Domain.")
    is_delete: Optional[StrictBool] = None
    mapped_entity_name: Optional[StrictStr] = None
    name: Optional[StrictStr] = Field(default=None, description="Name of Tag Domain.")
    properties: Optional[StrictStr] = None
    purpose: Optional[StrictStr] = Field(default=None, description="Purpose of  Domain.")
    tags: Optional[List[Assetsv3Tag]] = None
    updated_time: Optional[datetime] = None
    utc_offset: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["creation_time", "creation_time_utc", "description", "grouper", "id", "is_delete", "mapped_entity_name", "name", "properties", "purpose", "tags", "updated_time", "utc_offset"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Assetsv3TagCategory from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item in self.tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tags'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Assetsv3TagCategory from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "creation_time": obj.get("creation_time"),
            "creation_time_utc": obj.get("creation_time_utc"),
            "description": obj.get("description"),
            "grouper": obj.get("grouper"),
            "id": obj.get("id"),
            "is_delete": obj.get("is_delete"),
            "mapped_entity_name": obj.get("mapped_entity_name"),
            "name": obj.get("name"),
            "properties": obj.get("properties"),
            "purpose": obj.get("purpose"),
            "tags": [Assetsv3Tag.from_dict(_item) for _item in obj["tags"]] if obj.get("tags") is not None else None,
            "updated_time": obj.get("updated_time"),
            "utc_offset": obj.get("utc_offset")
        })
        return _obj


