# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Auditv3PutActivityRecordRequest(BaseModel):
    """
    PutActivityRecord creates an activity log record.  All fields are optional.  Specified fields will be used to included in the persisted ActivityRecord.  If no fields are specified then no activity log record is persisted.
    """ # noqa: E501
    action_taken: Optional[StrictStr] = Field(default=None, description="The operation associated with the persisted Activity record (CRUD or other).")
    changes_made: Optional[StrictStr] = Field(default=None, description="The reason the operation was performed (details about the operation).")
    context: Optional[StrictStr] = Field(default=None, description="The service/collection on which the operation was performed.")
    context_description: Optional[StrictStr] = Field(default=None, description="The label of the Activity record.")
    performed_by: Optional[StrictStr] = Field(default=None, description="The user id of the active user at the time the action was performed.")
    uid: Optional[StrictStr] = Field(default=None, description="The record ID with the persisted Activity record.")
    __properties: ClassVar[List[str]] = ["action_taken", "changes_made", "context", "context_description", "performed_by", "uid"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Auditv3PutActivityRecordRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Auditv3PutActivityRecordRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "action_taken": obj.get("action_taken"),
            "changes_made": obj.get("changes_made"),
            "context": obj.get("context"),
            "context_description": obj.get("context_description"),
            "performed_by": obj.get("performed_by"),
            "uid": obj.get("uid")
        })
        return _obj


