# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.featureflagsv3_feature_flag_value import Featureflagsv3FeatureFlagValue
from ibm_gdsc_sdk_software.models.tenantuserv3_full_user import Tenantuserv3FullUser
from typing import Optional, Set
from typing_extensions import Self

class AuthserverGetUserResponse(BaseModel):
    """
    Response parameters for get privillage.
    """ # noqa: E501
    feature_flags: Optional[Dict[str, Featureflagsv3FeatureFlagValue]] = Field(default=None, description="Feature flags map.")
    user: Optional[Tenantuserv3FullUser] = None
    __properties: ClassVar[List[str]] = ["feature_flags", "user"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthserverGetUserResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in feature_flags (dict)
        _field_dict = {}
        if self.feature_flags:
            for _key in self.feature_flags:
                if self.feature_flags[_key]:
                    _field_dict[_key] = self.feature_flags[_key].to_dict()
            _dict['feature_flags'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthserverGetUserResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "feature_flags": dict(
                (_k, Featureflagsv3FeatureFlagValue.from_dict(_v))
                for _k, _v in obj["feature_flags"].items()
            )
            if obj.get("feature_flags") is not None
            else None,
            "user": Tenantuserv3FullUser.from_dict(obj["user"]) if obj.get("user") is not None else None
        })
        return _obj


