# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.complianceacceleratorv3_action import Complianceacceleratorv3Action
from typing import Optional, Set
from typing_extensions import Self

class Complianceacceleratorv3RuleAndAction(BaseModel):
    """
    Policy rule and action for alerts.
    """ # noqa: E501
    actions: Optional[Dict[str, Complianceacceleratorv3Action]] = Field(default=None, description="Action name.")
    rule_id: Optional[StrictStr] = Field(default=None, description="Rule id.")
    __properties: ClassVar[List[str]] = ["actions", "rule_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Complianceacceleratorv3RuleAndAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in actions (dict)
        _field_dict = {}
        if self.actions:
            for _key in self.actions:
                if self.actions[_key]:
                    _field_dict[_key] = self.actions[_key].to_dict()
            _dict['actions'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Complianceacceleratorv3RuleAndAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "actions": dict(
                (_k, Complianceacceleratorv3Action.from_dict(_v))
                for _k, _v in obj["actions"].items()
            )
            if obj.get("actions") is not None
            else None,
            "rule_id": obj.get("rule_id")
        })
        return _obj


