# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Complianceacceleratorv3SyslogConfig(BaseModel):
    """
    Syslog alerts configuration.
    """ # noqa: E501
    host: Optional[StrictStr] = Field(default=None, description="Syslog post.")
    include_q_radar: Optional[StrictBool] = Field(default=None, description="Is q radar being used.")
    is_deletion: Optional[StrictBool] = Field(default=None, description="The syslog config is being deleted.")
    name: Optional[StrictStr] = Field(default=None, description="Syslog name.")
    port: Optional[StrictStr] = Field(default=None, description="Syslog port.")
    protocol: Optional[StrictStr] = Field(default=None, description="Syslog protocol UDP || TCP.")
    syslog_id: Optional[StrictStr] = Field(default=None, description="Syslog id.")
    template_id: Optional[StrictStr] = Field(default=None, description="Syslog template.")
    __properties: ClassVar[List[str]] = ["host", "include_q_radar", "is_deletion", "name", "port", "protocol", "syslog_id", "template_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Complianceacceleratorv3SyslogConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Complianceacceleratorv3SyslogConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "host": obj.get("host"),
            "include_q_radar": obj.get("include_q_radar"),
            "is_deletion": obj.get("is_deletion"),
            "name": obj.get("name"),
            "port": obj.get("port"),
            "protocol": obj.get("protocol"),
            "syslog_id": obj.get("syslog_id"),
            "template_id": obj.get("template_id")
        })
        return _obj


