# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.connectionsv3_connector_type import Connectionsv3ConnectorType
from ibm_gdsc_sdk_software.models.connectionsv3_stream_connection import Connectionsv3StreamConnection
from ibm_gdsc_sdk_software.models.connectionsv3_uc_connection_summary import Connectionsv3UCConnectionSummary
from typing import Optional, Set
from typing_extensions import Self

class Connectionsv3CreateConnectionsConfigsRequest(BaseModel):
    """
    Request parameters for create connection.
    """ # noqa: E501
    connection_id: Optional[StrictStr] = Field(default=None, description="Optional: connection id.")
    stream_connection: Optional[Connectionsv3StreamConnection] = None
    type: Optional[Connectionsv3ConnectorType] = None
    uc_connection: Optional[Connectionsv3UCConnectionSummary] = None
    __properties: ClassVar[List[str]] = ["connection_id", "stream_connection", "type", "uc_connection"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Connectionsv3CreateConnectionsConfigsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of stream_connection
        if self.stream_connection:
            _dict['stream_connection'] = self.stream_connection.to_dict()
        # override the default output from pydantic by calling `to_dict()` of uc_connection
        if self.uc_connection:
            _dict['uc_connection'] = self.uc_connection.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Connectionsv3CreateConnectionsConfigsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "connection_id": obj.get("connection_id"),
            "stream_connection": Connectionsv3StreamConnection.from_dict(obj["stream_connection"]) if obj.get("stream_connection") is not None else None,
            "type": obj.get("type"),
            "uc_connection": Connectionsv3UCConnectionSummary.from_dict(obj["uc_connection"]) if obj.get("uc_connection") is not None else None
        })
        return _obj


