# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.dashboardsv3_card_position import Dashboardsv3CardPosition
from ibm_gdsc_sdk_software.models.dashboardsv3_card_type import Dashboardsv3CardType
from ibm_gdsc_sdk_software.models.dashboardsv3_report_parameters import Dashboardsv3ReportParameters
from typing import Optional, Set
from typing_extensions import Self

class Dashboardsv3Card(BaseModel):
    """
    Cards - a small-scale representation of a Dashboard Card.
    """ # noqa: E501
    card_id: Optional[StrictStr] = Field(default=None, description="Card ID.", alias="card_ID")
    card_position: Optional[Dashboardsv3CardPosition] = None
    card_type: Optional[Dashboardsv3CardType] = None
    excluded_global_filter_ids: Optional[List[StrictStr]] = None
    report_parameters: Optional[Dashboardsv3ReportParameters] = None
    __properties: ClassVar[List[str]] = ["card_ID", "card_position", "card_type", "excluded_global_filter_ids", "report_parameters"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Dashboardsv3Card from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of card_position
        if self.card_position:
            _dict['card_position'] = self.card_position.to_dict()
        # override the default output from pydantic by calling `to_dict()` of report_parameters
        if self.report_parameters:
            _dict['report_parameters'] = self.report_parameters.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Dashboardsv3Card from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "card_ID": obj.get("card_ID"),
            "card_position": Dashboardsv3CardPosition.from_dict(obj["card_position"]) if obj.get("card_position") is not None else None,
            "card_type": obj.get("card_type"),
            "excluded_global_filter_ids": obj.get("excluded_global_filter_ids"),
            "report_parameters": Dashboardsv3ReportParameters.from_dict(obj["report_parameters"]) if obj.get("report_parameters") is not None else None
        })
        return _obj


