# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.dashboardsv3_card import Dashboardsv3Card
from ibm_gdsc_sdk_software.models.dashboardsv3_report_global_filter import Dashboardsv3ReportGlobalFilter
from ibm_gdsc_sdk_software.models.dashboardsv3_time_range import Dashboardsv3TimeRange
from typing import Optional, Set
from typing_extensions import Self

class Dashboardsv3Dashboard(BaseModel):
    """
    Dashboard - a small-scale representation of a Dashboard.
    """ # noqa: E501
    cards: Optional[List[Dashboardsv3Card]] = Field(default=None, description="Dashboard cards.")
    dashboard_description: Optional[StrictStr] = Field(default=None, description="Dashboard description.")
    dashboard_id: Optional[StrictStr] = Field(default=None, description="Unique Dashboard ID.")
    dashboard_title: Optional[StrictStr] = Field(default=None, description="Dashboard title.")
    global_time_filter: Optional[Dashboardsv3TimeRange] = None
    report_global_filter_list: Optional[List[Dashboardsv3ReportGlobalFilter]] = None
    __properties: ClassVar[List[str]] = ["cards", "dashboard_description", "dashboard_id", "dashboard_title", "global_time_filter", "report_global_filter_list"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Dashboardsv3Dashboard from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in cards (list)
        _items = []
        if self.cards:
            for _item in self.cards:
                if _item:
                    _items.append(_item.to_dict())
            _dict['cards'] = _items
        # override the default output from pydantic by calling `to_dict()` of global_time_filter
        if self.global_time_filter:
            _dict['global_time_filter'] = self.global_time_filter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in report_global_filter_list (list)
        _items = []
        if self.report_global_filter_list:
            for _item in self.report_global_filter_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['report_global_filter_list'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Dashboardsv3Dashboard from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cards": [Dashboardsv3Card.from_dict(_item) for _item in obj["cards"]] if obj.get("cards") is not None else None,
            "dashboard_description": obj.get("dashboard_description"),
            "dashboard_id": obj.get("dashboard_id"),
            "dashboard_title": obj.get("dashboard_title"),
            "global_time_filter": Dashboardsv3TimeRange.from_dict(obj["global_time_filter"]) if obj.get("global_time_filter") is not None else None,
            "report_global_filter_list": [Dashboardsv3ReportGlobalFilter.from_dict(_item) for _item in obj["report_global_filter_list"]] if obj.get("report_global_filter_list") is not None else None
        })
        return _obj


