# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.dashboardsv3_report_operator import Dashboardsv3ReportOperator
from typing import Optional, Set
from typing_extensions import Self

class Dashboardsv3ReportGlobalFilter(BaseModel):
    """
    Dashboardsv3ReportGlobalFilter
    """ # noqa: E501
    case_insensitive: Optional[StrictBool] = None
    filter_item_type: Optional[StrictStr] = None
    group_name: Optional[StrictStr] = None
    header_id: Optional[StrictStr] = None
    header_type: Optional[StrictStr] = None
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    operator: Optional[StrictStr] = None
    operator_key: Optional[StrictStr] = None
    report_operator: Optional[List[Dashboardsv3ReportOperator]] = None
    __properties: ClassVar[List[str]] = ["case_insensitive", "filter_item_type", "group_name", "header_id", "header_type", "id", "name", "operator", "operator_key", "report_operator"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Dashboardsv3ReportGlobalFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in report_operator (list)
        _items = []
        if self.report_operator:
            for _item in self.report_operator:
                if _item:
                    _items.append(_item.to_dict())
            _dict['report_operator'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Dashboardsv3ReportGlobalFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "case_insensitive": obj.get("case_insensitive"),
            "filter_item_type": obj.get("filter_item_type"),
            "group_name": obj.get("group_name"),
            "header_id": obj.get("header_id"),
            "header_type": obj.get("header_type"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "operator": obj.get("operator"),
            "operator_key": obj.get("operator_key"),
            "report_operator": [Dashboardsv3ReportOperator.from_dict(_item) for _item in obj["report_operator"]] if obj.get("report_operator") is not None else None
        })
        return _obj


