# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.dashboardsv3_dashboard import Dashboardsv3Dashboard
from ibm_gdsc_sdk_software.models.dashboardsv3_update_type import Dashboardsv3UpdateType
from typing import Optional, Set
from typing_extensions import Self

class Dashboardsv3UpdateDashboardRequest(BaseModel):
    """
    UpdateDashboardRequest is the argument type used to update a dashboard with the UpdateDashboard() api.
    """ # noqa: E501
    dashboard: Optional[Dashboardsv3Dashboard] = None
    dashboard_id: Optional[StrictStr] = Field(default=None, description="The id of the dashboard that was updated.")
    update_hint: Optional[StrictStr] = Field(default=None, description="Optional: A hint describing the update used by the activity log.")
    update_type: Optional[Dashboardsv3UpdateType] = None
    __properties: ClassVar[List[str]] = ["dashboard", "dashboard_id", "update_hint", "update_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Dashboardsv3UpdateDashboardRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of dashboard
        if self.dashboard:
            _dict['dashboard'] = self.dashboard.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Dashboardsv3UpdateDashboardRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dashboard": Dashboardsv3Dashboard.from_dict(obj["dashboard"]) if obj.get("dashboard") is not None else None,
            "dashboard_id": obj.get("dashboard_id"),
            "update_hint": obj.get("update_hint"),
            "update_type": obj.get("update_type")
        })
        return _obj


