# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from ibm_gdsc_sdk_software.models.data_resources_summary_resource_owners_inner import DataResourcesSummaryResourceOwnersInner
from ibm_gdsc_sdk_software.models.data_resources_summary_resource_types_inner import DataResourcesSummaryResourceTypesInner
from ibm_gdsc_sdk_software.models.sensitivities_items_inner import SensitivitiesItemsInner
from typing import Optional, Set
from typing_extensions import Self

class DataResourcesSummary(BaseModel):
    """
    DataResourcesSummary
    """ # noqa: E501
    reviewed_resources: Union[StrictFloat, StrictInt] = Field(alias="reviewedResources")
    total_resources: Union[StrictFloat, StrictInt] = Field(alias="totalResources")
    resource_types: List[DataResourcesSummaryResourceTypesInner] = Field(alias="resourceTypes")
    resource_owners: Optional[List[DataResourcesSummaryResourceOwnersInner]] = Field(default=None, alias="resourceOwners")
    total_sensitivities: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="totalSensitivities")
    sensitivities: List[SensitivitiesItemsInner]
    __properties: ClassVar[List[str]] = ["reviewedResources", "totalResources", "resourceTypes", "resourceOwners", "totalSensitivities", "sensitivities"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataResourcesSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in resource_types (list)
        _items = []
        if self.resource_types:
            for _item in self.resource_types:
                if _item:
                    _items.append(_item.to_dict())
            _dict['resourceTypes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in resource_owners (list)
        _items = []
        if self.resource_owners:
            for _item in self.resource_owners:
                if _item:
                    _items.append(_item.to_dict())
            _dict['resourceOwners'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sensitivities (list)
        _items = []
        if self.sensitivities:
            for _item in self.sensitivities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sensitivities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataResourcesSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reviewedResources": obj.get("reviewedResources"),
            "totalResources": obj.get("totalResources"),
            "resourceTypes": [DataResourcesSummaryResourceTypesInner.from_dict(_item) for _item in obj["resourceTypes"]] if obj.get("resourceTypes") is not None else None,
            "resourceOwners": [DataResourcesSummaryResourceOwnersInner.from_dict(_item) for _item in obj["resourceOwners"]] if obj.get("resourceOwners") is not None else None,
            "totalSensitivities": obj.get("totalSensitivities"),
            "sensitivities": [SensitivitiesItemsInner.from_dict(_item) for _item in obj["sensitivities"]] if obj.get("sensitivities") is not None else None
        })
        return _obj


