# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from ibm_gdsc_sdk_software.models.data_stores_summary_cloud_locations_inner import DataStoresSummaryCloudLocationsInner
from ibm_gdsc_sdk_software.models.data_stores_summary_service_providers_inner import DataStoresSummaryServiceProvidersInner
from ibm_gdsc_sdk_software.models.data_stores_summary_store_types_inner import DataStoresSummaryStoreTypesInner
from ibm_gdsc_sdk_software.models.sensitivities_items_inner import SensitivitiesItemsInner
from typing import Optional, Set
from typing_extensions import Self

class DataStoresSummary(BaseModel):
    """
    DataStoresSummary
    """ # noqa: E501
    total_stores: Union[StrictFloat, StrictInt] = Field(alias="totalStores")
    store_types: List[DataStoresSummaryStoreTypesInner] = Field(alias="storeTypes")
    cloud_locations: List[DataStoresSummaryCloudLocationsInner] = Field(alias="cloudLocations")
    service_providers: List[DataStoresSummaryServiceProvidersInner] = Field(alias="serviceProviders")
    total_sensitivities: Union[StrictFloat, StrictInt] = Field(alias="totalSensitivities")
    sensitivities: List[SensitivitiesItemsInner]
    total_potential_flows: Union[StrictFloat, StrictInt] = Field(alias="totalPotentialFlows")
    total_actual_flows: Union[StrictFloat, StrictInt] = Field(alias="totalActualFlows")
    total_sensitive_stores: Union[StrictFloat, StrictInt] = Field(alias="totalSensitiveStores")
    accounts_ids: List[StrictStr] = Field(alias="accountsIds")
    __properties: ClassVar[List[str]] = ["totalStores", "storeTypes", "cloudLocations", "serviceProviders", "totalSensitivities", "sensitivities", "totalPotentialFlows", "totalActualFlows", "totalSensitiveStores", "accountsIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataStoresSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in store_types (list)
        _items = []
        if self.store_types:
            for _item in self.store_types:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storeTypes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in cloud_locations (list)
        _items = []
        if self.cloud_locations:
            for _item in self.cloud_locations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['cloudLocations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in service_providers (list)
        _items = []
        if self.service_providers:
            for _item in self.service_providers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['serviceProviders'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sensitivities (list)
        _items = []
        if self.sensitivities:
            for _item in self.sensitivities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sensitivities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataStoresSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalStores": obj.get("totalStores"),
            "storeTypes": [DataStoresSummaryStoreTypesInner.from_dict(_item) for _item in obj["storeTypes"]] if obj.get("storeTypes") is not None else None,
            "cloudLocations": [DataStoresSummaryCloudLocationsInner.from_dict(_item) for _item in obj["cloudLocations"]] if obj.get("cloudLocations") is not None else None,
            "serviceProviders": [DataStoresSummaryServiceProvidersInner.from_dict(_item) for _item in obj["serviceProviders"]] if obj.get("serviceProviders") is not None else None,
            "totalSensitivities": obj.get("totalSensitivities"),
            "sensitivities": [SensitivitiesItemsInner.from_dict(_item) for _item in obj["sensitivities"]] if obj.get("sensitivities") is not None else None,
            "totalPotentialFlows": obj.get("totalPotentialFlows"),
            "totalActualFlows": obj.get("totalActualFlows"),
            "totalSensitiveStores": obj.get("totalSensitiveStores"),
            "accountsIds": obj.get("accountsIds")
        })
        return _obj


