# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.groupbuilderv3_group_member import Groupbuilderv3GroupMember
from ibm_gdsc_sdk_software.models.groupbuilderv3_ldap_config import Groupbuilderv3LdapConfig
from typing import Optional, Set
from typing_extensions import Self

class Groupbuilderv3EditGroupRequest(BaseModel):
    """
    EditGroupRequest request an update to the group members of a specific group ID.
    """ # noqa: E501
    clear_group: Optional[StrictBool] = Field(default=None, description="Clear the group member.")
    deleted_members: Optional[List[StrictStr]] = Field(default=None, description="Group member ID to delete.")
    description: Optional[StrictStr] = Field(default=None, description="Group description.")
    group_id: Optional[StrictInt] = Field(default=None, description="Group ID.")
    ldap_config: Optional[Groupbuilderv3LdapConfig] = None
    name: Optional[StrictStr] = Field(default=None, description="Group name.")
    new_members: Optional[List[StrictStr]] = Field(default=None, description="New members to add.")
    updated_members: Optional[List[Groupbuilderv3GroupMember]] = Field(default=None, description="Group members to update.")
    __properties: ClassVar[List[str]] = ["clear_group", "deleted_members", "description", "group_id", "ldap_config", "name", "new_members", "updated_members"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Groupbuilderv3EditGroupRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ldap_config
        if self.ldap_config:
            _dict['ldap_config'] = self.ldap_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in updated_members (list)
        _items = []
        if self.updated_members:
            for _item in self.updated_members:
                if _item:
                    _items.append(_item.to_dict())
            _dict['updated_members'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Groupbuilderv3EditGroupRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clear_group": obj.get("clear_group"),
            "deleted_members": obj.get("deleted_members"),
            "description": obj.get("description"),
            "group_id": obj.get("group_id"),
            "ldap_config": Groupbuilderv3LdapConfig.from_dict(obj["ldap_config"]) if obj.get("ldap_config") is not None else None,
            "name": obj.get("name"),
            "new_members": obj.get("new_members"),
            "updated_members": [Groupbuilderv3GroupMember.from_dict(_item) for _item in obj["updated_members"]] if obj.get("updated_members") is not None else None
        })
        return _obj


