# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Groupbuilderv3GdpGroup(BaseModel):
    """
    Groupbuilderv3GdpGroup
    """ # noqa: E501
    application: Optional[StrictStr] = Field(default=None, description="Application of the group.")
    description: Optional[StrictStr] = Field(default=None, description="Name of the group.")
    hierarchical: Optional[StrictBool] = Field(default=None, description="If the group is nested or not.")
    id: Optional[StrictInt] = Field(default=None, description="GDP group ID.")
    member_count: Optional[StrictInt] = Field(default=None, description="Number of group members.")
    members: Optional[StrictStr] = Field(default=None, description="Json object of nested or regular members.")
    tuple_count: Optional[StrictInt] = Field(default=None, description="Number of tuples.")
    tuples: Optional[StrictStr] = Field(default=None, description="The tuples of the group.")
    type: Optional[StrictStr] = Field(default=None, description="GDP type name.")
    type_id: Optional[StrictInt] = Field(default=None, description="GDP type ID of group.")
    __properties: ClassVar[List[str]] = ["application", "description", "hierarchical", "id", "member_count", "members", "tuple_count", "tuples", "type", "type_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Groupbuilderv3GdpGroup from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Groupbuilderv3GdpGroup from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "application": obj.get("application"),
            "description": obj.get("description"),
            "hierarchical": obj.get("hierarchical"),
            "id": obj.get("id"),
            "member_count": obj.get("member_count"),
            "members": obj.get("members"),
            "tuple_count": obj.get("tuple_count"),
            "tuples": obj.get("tuples"),
            "type": obj.get("type"),
            "type_id": obj.get("type_id")
        })
        return _obj


