# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_group_member import Guardiumconnectorv3GroupMember
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_nested_group_member import Guardiumconnectorv3NestedGroupMember
from typing import Optional, Set
from typing_extensions import Self

class Guardiumconnectorv3Group(BaseModel):
    """
    Return details about the groups defined on a Guardium system.
    """ # noqa: E501
    application: Optional[StrictStr] = Field(default=None, description="Application associated with the group.")
    description: Optional[StrictStr] = Field(default=None, description="Group name.")
    group_id: Optional[StrictInt] = Field(default=None, description="Group ID.")
    group_type_id: Optional[StrictInt] = Field(default=None, description="Group type ID.")
    hierarchical: Optional[StrictBool] = Field(default=None, description="Group is nested (hierarchical).")
    member_count: Optional[StrictInt] = Field(default=None, description="Number of members in group.")
    members: Optional[List[Guardiumconnectorv3GroupMember]] = Field(default=None, description="List of group members.")
    nested_group_members: Optional[List[Guardiumconnectorv3NestedGroupMember]] = Field(default=None, description="Array of group members.")
    tuple_count: Optional[StrictInt] = Field(default=None, description="Number of tuples in group.")
    tuples: Optional[StrictStr] = Field(default=None, description="Name of tuples in group type.")
    type: Optional[StrictInt] = Field(default=None, description="Group type.")
    __properties: ClassVar[List[str]] = ["application", "description", "group_id", "group_type_id", "hierarchical", "member_count", "members", "nested_group_members", "tuple_count", "tuples", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3Group from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in members (list)
        _items = []
        if self.members:
            for _item in self.members:
                if _item:
                    _items.append(_item.to_dict())
            _dict['members'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in nested_group_members (list)
        _items = []
        if self.nested_group_members:
            for _item in self.nested_group_members:
                if _item:
                    _items.append(_item.to_dict())
            _dict['nested_group_members'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3Group from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "application": obj.get("application"),
            "description": obj.get("description"),
            "group_id": obj.get("group_id"),
            "group_type_id": obj.get("group_type_id"),
            "hierarchical": obj.get("hierarchical"),
            "member_count": obj.get("member_count"),
            "members": [Guardiumconnectorv3GroupMember.from_dict(_item) for _item in obj["members"]] if obj.get("members") is not None else None,
            "nested_group_members": [Guardiumconnectorv3NestedGroupMember.from_dict(_item) for _item in obj["nested_group_members"]] if obj.get("nested_group_members") is not None else None,
            "tuple_count": obj.get("tuple_count"),
            "tuples": obj.get("tuples"),
            "type": obj.get("type")
        })
        return _obj


