# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_action import Guardiumconnectorv3Action
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_rule_parameter import Guardiumconnectorv3RuleParameter
from typing import Optional, Set
from typing_extensions import Self

class Guardiumconnectorv3Rule(BaseModel):
    """
    Guardiumconnectorv3Rule
    """ # noqa: E501
    actions: Optional[List[Guardiumconnectorv3Action]] = None
    continue_to_next_rule: Optional[StrictBool] = None
    parameters: Optional[List[Guardiumconnectorv3RuleParameter]] = None
    rule_level: Optional[StrictInt] = None
    rule_name: Optional[StrictStr] = None
    rule_type: Optional[StrictStr] = None
    severity: Optional[StrictStr] = None
    tags: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = ["actions", "continue_to_next_rule", "parameters", "rule_level", "rule_name", "rule_type", "severity", "tags"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3Rule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in actions (list)
        _items = []
        if self.actions:
            for _item in self.actions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['actions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in parameters (list)
        _items = []
        if self.parameters:
            for _item in self.parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['parameters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3Rule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "actions": [Guardiumconnectorv3Action.from_dict(_item) for _item in obj["actions"]] if obj.get("actions") is not None else None,
            "continue_to_next_rule": obj.get("continue_to_next_rule"),
            "parameters": [Guardiumconnectorv3RuleParameter.from_dict(_item) for _item in obj["parameters"]] if obj.get("parameters") is not None else None,
            "rule_level": obj.get("rule_level"),
            "rule_name": obj.get("rule_name"),
            "rule_type": obj.get("rule_type"),
            "severity": obj.get("severity"),
            "tags": obj.get("tags")
        })
        return _obj


