# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_gdp_report_result_row import Guardiumconnectorv3GDPReportResultRow
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_status_response_base import Guardiumconnectorv3StatusResponseBase
from typing import Optional, Set
from typing_extensions import Self

class Guardiumconnectorv3RunGDPReportResponse(BaseModel):
    """
    Returns the data from report run.
    """ # noqa: E501
    report_data: Optional[List[Guardiumconnectorv3GDPReportResultRow]] = Field(default=None, description="Report data.")
    status: Optional[Guardiumconnectorv3StatusResponseBase] = None
    __properties: ClassVar[List[str]] = ["report_data", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3RunGDPReportResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in report_data (list)
        _items = []
        if self.report_data:
            for _item in self.report_data:
                if _item:
                    _items.append(_item.to_dict())
            _dict['report_data'] = _items
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3RunGDPReportResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "report_data": [Guardiumconnectorv3GDPReportResultRow.from_dict(_item) for _item in obj["report_data"]] if obj.get("report_data") is not None else None,
            "status": Guardiumconnectorv3StatusResponseBase.from_dict(obj["status"]) if obj.get("status") is not None else None
        })
        return _obj


