# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_status_attribute import Guardiumconnectorv3StatusAttribute
from typing import Optional, Set
from typing_extensions import Self

class Guardiumconnectorv3StatusRecord(BaseModel):
    """
    StatusRecord is the streaming status for each Guardium unit returned by grdapi.
    """ # noqa: E501
    attributes: Optional[List[Guardiumconnectorv3StatusAttribute]] = Field(default=None, description="Attributes of the Guardium unit (version, unitType, isUnitOnline, etc).")
    host_name: Optional[StrictStr] = Field(default=None, description="Hostname as its being sent by GDP.", alias="hostName")
    message: Optional[StrictStr] = Field(default=None, description="Message describing status.")
    state: Optional[StrictStr] = Field(default=None, description="Streaming state: enabled, disabled.")
    status: Optional[StrictStr] = Field(default=None, description="Current status of streaming (e.g sucess,failed,...).")
    __properties: ClassVar[List[str]] = ["attributes", "hostName", "message", "state", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3StatusRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in attributes (list)
        _items = []
        if self.attributes:
            for _item in self.attributes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['attributes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3StatusRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attributes": [Guardiumconnectorv3StatusAttribute.from_dict(_item) for _item in obj["attributes"]] if obj.get("attributes") is not None else None,
            "hostName": obj.get("hostName"),
            "message": obj.get("message"),
            "state": obj.get("state"),
            "status": obj.get("status")
        })
        return _obj


