# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_attribute import Guardiumconnectorv3Attribute
from typing import Optional, Set
from typing_extensions import Self

class Guardiumconnectorv3StreamingStatusRecord(BaseModel):
    """
    Streaming status for a particular Managed Unit.
    """ # noqa: E501
    attributes: Optional[List[Guardiumconnectorv3Attribute]] = Field(default=None, description="Name/value pair attributes stored in config db.")
    message: Optional[StrictStr] = Field(default=None, description="Message describing status.")
    mu: Optional[StrictStr] = Field(default=None, description="MU Name.")
    state: Optional[StrictStr] = Field(default=None, description="Streaming state : enabled, disabled.")
    status: Optional[StrictStr] = Field(default=None, description="Streaming configuration current status (e.g RUNNING,DONE,FAILED,...).")
    unit_type: Optional[StrictStr] = Field(default=None, description="Type of managed unit (Collector or Aggregator).")
    __properties: ClassVar[List[str]] = ["attributes", "message", "mu", "state", "status", "unit_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3StreamingStatusRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in attributes (list)
        _items = []
        if self.attributes:
            for _item in self.attributes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['attributes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3StreamingStatusRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attributes": [Guardiumconnectorv3Attribute.from_dict(_item) for _item in obj["attributes"]] if obj.get("attributes") is not None else None,
            "message": obj.get("message"),
            "mu": obj.get("mu"),
            "state": obj.get("state"),
            "status": obj.get("status"),
            "unit_type": obj.get("unit_type")
        })
        return _obj


