# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_sub_task_object import Guardiumconnectorv3SubTaskObject
from ibm_gdsc_sdk_software.models.guardiumconnectorv3_task_definition_object import Guardiumconnectorv3TaskDefinitionObject
from typing import Optional, Set
from typing_extensions import Self

class Guardiumconnectorv3TaskObject(BaseModel):
    """
    Object holding task info.
    """ # noqa: E501
    sub_tasks: Optional[List[Guardiumconnectorv3SubTaskObject]] = Field(default=None, description="Sub tasks.")
    task_definition: Optional[Guardiumconnectorv3TaskDefinitionObject] = None
    __properties: ClassVar[List[str]] = ["sub_tasks", "task_definition"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3TaskObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in sub_tasks (list)
        _items = []
        if self.sub_tasks:
            for _item in self.sub_tasks:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sub_tasks'] = _items
        # override the default output from pydantic by calling `to_dict()` of task_definition
        if self.task_definition:
            _dict['task_definition'] = self.task_definition.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Guardiumconnectorv3TaskObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sub_tasks": [Guardiumconnectorv3SubTaskObject.from_dict(_item) for _item in obj["sub_tasks"]] if obj.get("sub_tasks") is not None else None,
            "task_definition": Guardiumconnectorv3TaskDefinitionObject.from_dict(obj["task_definition"]) if obj.get("task_definition") is not None else None
        })
        return _obj


