# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.healthcollectorv3_count_object import Healthcollectorv3CountObject
from ibm_gdsc_sdk_software.models.healthcollectorv3_stap_information_object import Healthcollectorv3StapInformationObject
from typing import Optional, Set
from typing_extensions import Self

class Healthcollectorv3HistoricalDataObject(BaseModel):
    """
    S-tap Historical data object.
    """ # noqa: E501
    cm_id: Optional[StrictStr] = Field(default=None, description="Cm Id.")
    inspection_engine_counts: Optional[List[Healthcollectorv3CountObject]] = Field(default=None, description="Inspection engine counts over a period of time.")
    nodes: Optional[List[Healthcollectorv3StapInformationObject]] = Field(default=None, description="Detailed information about staps.")
    stap_counts: Optional[List[Healthcollectorv3CountObject]] = Field(default=None, description="Stap counts over a period of time.")
    staps_added: Optional[StrictInt] = Field(default=None, description="Count of staps added.")
    staps_removed: Optional[StrictInt] = Field(default=None, description="Count of staps removed.")
    staps_with_ie_changes: Optional[StrictInt] = Field(default=None, description="Count of staps that had ie changes.")
    __properties: ClassVar[List[str]] = ["cm_id", "inspection_engine_counts", "nodes", "stap_counts", "staps_added", "staps_removed", "staps_with_ie_changes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Healthcollectorv3HistoricalDataObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in inspection_engine_counts (list)
        _items = []
        if self.inspection_engine_counts:
            for _item in self.inspection_engine_counts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['inspection_engine_counts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in nodes (list)
        _items = []
        if self.nodes:
            for _item in self.nodes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['nodes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in stap_counts (list)
        _items = []
        if self.stap_counts:
            for _item in self.stap_counts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['stap_counts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Healthcollectorv3HistoricalDataObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cm_id": obj.get("cm_id"),
            "inspection_engine_counts": [Healthcollectorv3CountObject.from_dict(_item) for _item in obj["inspection_engine_counts"]] if obj.get("inspection_engine_counts") is not None else None,
            "nodes": [Healthcollectorv3StapInformationObject.from_dict(_item) for _item in obj["nodes"]] if obj.get("nodes") is not None else None,
            "stap_counts": [Healthcollectorv3CountObject.from_dict(_item) for _item in obj["stap_counts"]] if obj.get("stap_counts") is not None else None,
            "staps_added": obj.get("staps_added"),
            "staps_removed": obj.get("staps_removed"),
            "staps_with_ie_changes": obj.get("staps_with_ie_changes")
        })
        return _obj


