# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.healthcollectorv3_inspection_engine_present_details import Healthcollectorv3InspectionEnginePresentDetails
from ibm_gdsc_sdk_software.models.healthcollectorv3_stap_object import Healthcollectorv3StapObject
from typing import Optional, Set
from typing_extensions import Self

class Healthcollectorv3StapInformationObject(BaseModel):
    """
    S-tap related information object.
    """ # noqa: E501
    inspection_engine_details: Optional[List[Healthcollectorv3InspectionEnginePresentDetails]] = Field(default=None, description="Details of inspection engines present at start and end.")
    inspection_engine_details_change: Optional[StrictInt] = Field(default=None, description="Difference of inspection engines present at start and end.")
    present_at_end: Optional[StrictBool] = Field(default=None, description="Indicates whether the s-tap was present at end.")
    present_at_start: Optional[StrictBool] = Field(default=None, description="Indicates whether the s-tap was present at start.")
    stap: Optional[Healthcollectorv3StapObject] = None
    __properties: ClassVar[List[str]] = ["inspection_engine_details", "inspection_engine_details_change", "present_at_end", "present_at_start", "stap"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Healthcollectorv3StapInformationObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in inspection_engine_details (list)
        _items = []
        if self.inspection_engine_details:
            for _item in self.inspection_engine_details:
                if _item:
                    _items.append(_item.to_dict())
            _dict['inspection_engine_details'] = _items
        # override the default output from pydantic by calling `to_dict()` of stap
        if self.stap:
            _dict['stap'] = self.stap.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Healthcollectorv3StapInformationObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "inspection_engine_details": [Healthcollectorv3InspectionEnginePresentDetails.from_dict(_item) for _item in obj["inspection_engine_details"]] if obj.get("inspection_engine_details") is not None else None,
            "inspection_engine_details_change": obj.get("inspection_engine_details_change"),
            "present_at_end": obj.get("present_at_end"),
            "present_at_start": obj.get("present_at_start"),
            "stap": Healthcollectorv3StapObject.from_dict(obj["stap"]) if obj.get("stap") is not None else None
        })
        return _obj


