# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Jumpboxv3AuthorizeRequest(BaseModel):
    """
    AuthorizeRequest message for POST v3/Authorize api.
    """ # noqa: E501
    display_name: Optional[StrictStr] = Field(default=None, description="Display name of the user.")
    email: Optional[StrictStr] = Field(default=None, description="Contact email address of the user.")
    external_id: Optional[StrictStr] = Field(default=None, description="External id of the user.")
    first_name: Optional[StrictStr] = Field(default=None, description="First name of the user.")
    is_renew: Optional[StrictBool] = Field(default=None, description="If it is a renew.")
    is_update_user_info: Optional[StrictBool] = Field(default=None, description="Whether to update the user info with ISV during login.")
    last_name: Optional[StrictStr] = Field(default=None, description="Last name of the user.")
    login_id: Optional[StrictStr] = Field(default=None, description="Login id of the user.")
    tenant_id: Optional[StrictStr] = Field(default=None, description="Tenant id.")
    __properties: ClassVar[List[str]] = ["display_name", "email", "external_id", "first_name", "is_renew", "is_update_user_info", "last_name", "login_id", "tenant_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Jumpboxv3AuthorizeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Jumpboxv3AuthorizeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "display_name": obj.get("display_name"),
            "email": obj.get("email"),
            "external_id": obj.get("external_id"),
            "first_name": obj.get("first_name"),
            "is_renew": obj.get("is_renew"),
            "is_update_user_info": obj.get("is_update_user_info"),
            "last_name": obj.get("last_name"),
            "login_id": obj.get("login_id"),
            "tenant_id": obj.get("tenant_id")
        })
        return _obj


