# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.outliersenginev3_datasources_coverage_stats import Outliersenginev3DatasourcesCoverageStats
from typing import Optional, Set
from typing_extensions import Self

class Outliersenginev3QueueStatisticsMessage(BaseModel):
    """
    StatisticsResponse is the message for the result from getStatistics.
    """ # noqa: E501
    coverage_1h: Optional[Outliersenginev3DatasourcesCoverageStats] = None
    coverage_24h: Optional[Outliersenginev3DatasourcesCoverageStats] = None
    coverage_72h: Optional[Outliersenginev3DatasourcesCoverageStats] = None
    tasks: Optional[StrictInt] = Field(default=None, description="Number of tasks in queue, in total.")
    tasks_done: Optional[StrictInt] = Field(default=None, description="Number of tasks done.")
    tasks_in_progress: Optional[StrictInt] = Field(default=None, description="Number of tasks in progress.")
    tasks_in_progress_2h: Optional[StrictInt] = Field(default=None, description="Number of tasks in progress, for over 2 hours.")
    tasks_new: Optional[StrictInt] = Field(default=None, description="Number of new tasks in queue.")
    tasks_new_2h: Optional[StrictInt] = Field(default=None, description="Number of new tasks in queue, for over 2 hours.")
    __properties: ClassVar[List[str]] = ["coverage_1h", "coverage_24h", "coverage_72h", "tasks", "tasks_done", "tasks_in_progress", "tasks_in_progress_2h", "tasks_new", "tasks_new_2h"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Outliersenginev3QueueStatisticsMessage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of coverage_1h
        if self.coverage_1h:
            _dict['coverage_1h'] = self.coverage_1h.to_dict()
        # override the default output from pydantic by calling `to_dict()` of coverage_24h
        if self.coverage_24h:
            _dict['coverage_24h'] = self.coverage_24h.to_dict()
        # override the default output from pydantic by calling `to_dict()` of coverage_72h
        if self.coverage_72h:
            _dict['coverage_72h'] = self.coverage_72h.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Outliersenginev3QueueStatisticsMessage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "coverage_1h": Outliersenginev3DatasourcesCoverageStats.from_dict(obj["coverage_1h"]) if obj.get("coverage_1h") is not None else None,
            "coverage_24h": Outliersenginev3DatasourcesCoverageStats.from_dict(obj["coverage_24h"]) if obj.get("coverage_24h") is not None else None,
            "coverage_72h": Outliersenginev3DatasourcesCoverageStats.from_dict(obj["coverage_72h"]) if obj.get("coverage_72h") is not None else None,
            "tasks": obj.get("tasks"),
            "tasks_done": obj.get("tasks_done"),
            "tasks_in_progress": obj.get("tasks_in_progress"),
            "tasks_in_progress_2h": obj.get("tasks_in_progress_2h"),
            "tasks_new": obj.get("tasks_new"),
            "tasks_new_2h": obj.get("tasks_new_2h")
        })
        return _obj


