# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Outliersenginev3WorkingHoursPeriod(BaseModel):
    """
    WorkingHoursPeriod represents a classification of hours of the day.
    """ # noqa: E501
    contiguous: Optional[StrictBool] = Field(default=None, description="Specify whether the period is contiguous or not.")
    datetime_code_description: Optional[StrictStr] = Field(default=None, description="Period description.")
    datetime_code_id: Optional[StrictInt] = Field(default=None, description="Period id.")
    hour_from: Optional[StrictStr] = Field(default=None, description="The hour that the period starts, format HH:mm.")
    hour_to: Optional[StrictStr] = Field(default=None, description="The hour that the period ends, format HH:mm.")
    weekday_from: Optional[StrictInt] = Field(default=None, description="The number of day that the period starts.")
    weekday_to: Optional[StrictInt] = Field(default=None, description="The number of day that the period ends.")
    __properties: ClassVar[List[str]] = ["contiguous", "datetime_code_description", "datetime_code_id", "hour_from", "hour_to", "weekday_from", "weekday_to"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Outliersenginev3WorkingHoursPeriod from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Outliersenginev3WorkingHoursPeriod from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contiguous": obj.get("contiguous"),
            "datetime_code_description": obj.get("datetime_code_description"),
            "datetime_code_id": obj.get("datetime_code_id"),
            "hour_from": obj.get("hour_from"),
            "hour_to": obj.get("hour_to"),
            "weekday_from": obj.get("weekday_from"),
            "weekday_to": obj.get("weekday_to")
        })
        return _obj


