# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Policybuilderv3ActionParameterMetadata(BaseModel):
    """
    Action parameter metadata object.
    """ # noqa: E501
    default_value: Optional[StrictStr] = Field(default=None, description="Default value of the parameter.")
    mandatory: Optional[StrictBool] = Field(default=None, description="Flag indicating if the parameter is manadatory or not.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the parameter.")
    possible_values: Optional[List[StrictStr]] = Field(default=None, description="Possible values of the parameter.")
    sequence: Optional[StrictInt] = Field(default=None, description="Sequence of the parameter.")
    type: Optional[StrictStr] = Field(default=None, description="TYpe of the Parameter like String, Number, Reg and so on.")
    __properties: ClassVar[List[str]] = ["default_value", "mandatory", "name", "possible_values", "sequence", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Policybuilderv3ActionParameterMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Policybuilderv3ActionParameterMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "default_value": obj.get("default_value"),
            "mandatory": obj.get("mandatory"),
            "name": obj.get("name"),
            "possible_values": obj.get("possible_values"),
            "sequence": obj.get("sequence"),
            "type": obj.get("type")
        })
        return _obj


