# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.policybuilderv3_gdp_policy_sync_res import Policybuilderv3GdpPolicySyncRes
from ibm_gdsc_sdk_software.models.policybuilderv3_status_response_base import Policybuilderv3StatusResponseBase
from typing import Optional, Set
from typing_extensions import Self

class Policybuilderv3InsertGdpPolicySyncResponse(BaseModel):
    """
    Policybuilderv3InsertGdpPolicySyncResponse
    """ # noqa: E501
    gdp_policies: Optional[List[Policybuilderv3GdpPolicySyncRes]] = None
    status: Optional[Policybuilderv3StatusResponseBase] = None
    __properties: ClassVar[List[str]] = ["gdp_policies", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Policybuilderv3InsertGdpPolicySyncResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in gdp_policies (list)
        _items = []
        if self.gdp_policies:
            for _item in self.gdp_policies:
                if _item:
                    _items.append(_item.to_dict())
            _dict['gdp_policies'] = _items
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Policybuilderv3InsertGdpPolicySyncResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "gdp_policies": [Policybuilderv3GdpPolicySyncRes.from_dict(_item) for _item in obj["gdp_policies"]] if obj.get("gdp_policies") is not None else None,
            "status": Policybuilderv3StatusResponseBase.from_dict(obj["status"]) if obj.get("status") is not None else None
        })
        return _obj


