# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.policybuilderv3_control_flow import Policybuilderv3ControlFlow
from ibm_gdsc_sdk_software.models.policybuilderv3_policy_type import Policybuilderv3PolicyType
from ibm_gdsc_sdk_software.models.policybuilderv3_rule import Policybuilderv3Rule
from typing import Optional, Set
from typing_extensions import Self

class Policybuilderv3PolicyUpdate(BaseModel):
    """
    Create and update policy request message.
    """ # noqa: E501
    activation_status: Optional[StrictInt] = Field(default=None, description="Activation status identifier: 1001 -> install with no issues, 1002-> installed with issues, 1003 -> not installed.")
    control_flow: Optional[Policybuilderv3ControlFlow] = None
    deleted_rule_ids: Optional[List[StrictStr]] = Field(default=None, description="The rule ids which are supposed to be deleted on a update policy request.", alias="deletedRuleIds")
    installed_flag: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether policy is installed or not.")
    installed_order: Optional[StrictInt] = Field(default=None, description="Variable to indicate the order of the installed policy.")
    installed_timestamp: Optional[StrictStr] = Field(default=None, description="Timestamp to indicate when the policy was installed.")
    last_edited_timestamp: Optional[StrictStr] = Field(default=None, description="Timestamp to indicate when the policy was last edited.")
    log_flat: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether the policy has log flat enabled or not.")
    policy_id: Optional[StrictStr] = Field(default=None, description="Policy Id.")
    policy_name: Optional[StrictStr] = Field(default=None, description="Policy Name.")
    policy_type: Optional[Policybuilderv3PolicyType] = None
    rules: Optional[List[Policybuilderv3Rule]] = None
    rules_on_flat: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether the policy has rules on flat enabled or not.")
    template: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether the policy is a template policy or not.")
    version: Optional[StrictInt] = Field(default=None, description="Version of the policy.")
    __properties: ClassVar[List[str]] = ["activation_status", "control_flow", "deletedRuleIds", "installed_flag", "installed_order", "installed_timestamp", "last_edited_timestamp", "log_flat", "policy_id", "policy_name", "policy_type", "rules", "rules_on_flat", "template", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Policybuilderv3PolicyUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rules (list)
        _items = []
        if self.rules:
            for _item in self.rules:
                if _item:
                    _items.append(_item.to_dict())
            _dict['rules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Policybuilderv3PolicyUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activation_status": obj.get("activation_status"),
            "control_flow": obj.get("control_flow"),
            "deletedRuleIds": obj.get("deletedRuleIds"),
            "installed_flag": obj.get("installed_flag"),
            "installed_order": obj.get("installed_order"),
            "installed_timestamp": obj.get("installed_timestamp"),
            "last_edited_timestamp": obj.get("last_edited_timestamp"),
            "log_flat": obj.get("log_flat"),
            "policy_id": obj.get("policy_id"),
            "policy_name": obj.get("policy_name"),
            "policy_type": obj.get("policy_type"),
            "rules": [Policybuilderv3Rule.from_dict(_item) for _item in obj["rules"]] if obj.get("rules") is not None else None,
            "rules_on_flat": obj.get("rules_on_flat"),
            "template": obj.get("template"),
            "version": obj.get("version")
        })
        return _obj


