# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from ibm_gdsc_sdk_software.models.access_type import AccessType
from ibm_gdsc_sdk_software.models.flow_node import FlowNode
from typing import Optional, Set
from typing_extensions import Self

class PotentialFlow(BaseModel):
    """
    PotentialFlow
    """ # noqa: E501
    id: StrictStr
    type: StrictStr
    source: FlowNode
    destination: FlowNode
    access_types: List[AccessType] = Field(alias="accessTypes")
    paths_count: Union[StrictFloat, StrictInt] = Field(alias="pathsCount")
    permitted_operations: List[StrictStr] = Field(alias="permittedOperations")
    __properties: ClassVar[List[str]] = ["id", "type", "source", "destination", "accessTypes", "pathsCount", "permittedOperations"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PotentialFlow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of destination
        if self.destination:
            _dict['destination'] = self.destination.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PotentialFlow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "source": FlowNode.from_dict(obj["source"]) if obj.get("source") is not None else None,
            "destination": FlowNode.from_dict(obj["destination"]) if obj.get("destination") is not None else None,
            "accessTypes": obj.get("accessTypes"),
            "pathsCount": obj.get("pathsCount"),
            "permittedOperations": obj.get("permittedOperations")
        })
        return _obj


