# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.protobuf_any import ProtobufAny
from typing import Optional, Set
from typing_extensions import Self

class Qspmdatamanagerv3MasterDataModel(BaseModel):
    """
    Qspmdatamanagerv3MasterDataModel
    """ # noqa: E501
    creation_ts: Optional[datetime] = None
    ref_desc: Optional[StrictStr] = None
    ref_has_schema: Optional[StrictBool] = None
    ref_id: Optional[StrictStr] = None
    ref_name: Optional[StrictStr] = None
    ref_schema: Optional[ProtobufAny] = None
    ref_type: Optional[StrictStr] = None
    ref_value: Optional[StrictStr] = None
    ref_version: Optional[StrictStr] = None
    updation_ts: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["creation_ts", "ref_desc", "ref_has_schema", "ref_id", "ref_name", "ref_schema", "ref_type", "ref_value", "ref_version", "updation_ts"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Qspmdatamanagerv3MasterDataModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ref_schema
        if self.ref_schema:
            _dict['ref_schema'] = self.ref_schema.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Qspmdatamanagerv3MasterDataModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "creation_ts": obj.get("creation_ts"),
            "ref_desc": obj.get("ref_desc"),
            "ref_has_schema": obj.get("ref_has_schema"),
            "ref_id": obj.get("ref_id"),
            "ref_name": obj.get("ref_name"),
            "ref_schema": ProtobufAny.from_dict(obj["ref_schema"]) if obj.get("ref_schema") is not None else None,
            "ref_type": obj.get("ref_type"),
            "ref_value": obj.get("ref_value"),
            "ref_version": obj.get("ref_version"),
            "updation_ts": obj.get("updation_ts")
        })
        return _obj


