# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.qspmpluginmanagerv3_entity_new_schema import Qspmpluginmanagerv3EntityNewSchema
from ibm_gdsc_sdk_software.models.qspmpluginmanagerv3_validation_result import Qspmpluginmanagerv3ValidationResult
from typing import Optional, Set
from typing_extensions import Self

class Qspmpluginmanagerv3PluginRS(BaseModel):
    """
    PluginRS is the response object for InvokePlugin,InvokeAppProv,InvokeExplorerV1,InvokeExplorerV2 API.
    """ # noqa: E501
    dims: Optional[List[Qspmpluginmanagerv3EntityNewSchema]] = None
    facts: Optional[List[Qspmpluginmanagerv3EntityNewSchema]] = None
    org_id: Optional[StrictStr] = None
    plugin_id: Optional[StrictStr] = None
    run_for_all_scans: Optional[StrictBool] = None
    scan_desc: Optional[StrictStr] = None
    scan_id: Optional[StrictStr] = None
    user_email: Optional[StrictStr] = None
    validation_result: Optional[Qspmpluginmanagerv3ValidationResult] = None
    __properties: ClassVar[List[str]] = ["dims", "facts", "org_id", "plugin_id", "run_for_all_scans", "scan_desc", "scan_id", "user_email", "validation_result"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Qspmpluginmanagerv3PluginRS from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in dims (list)
        _items = []
        if self.dims:
            for _item in self.dims:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dims'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in facts (list)
        _items = []
        if self.facts:
            for _item in self.facts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['facts'] = _items
        # override the default output from pydantic by calling `to_dict()` of validation_result
        if self.validation_result:
            _dict['validation_result'] = self.validation_result.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Qspmpluginmanagerv3PluginRS from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dims": [Qspmpluginmanagerv3EntityNewSchema.from_dict(_item) for _item in obj["dims"]] if obj.get("dims") is not None else None,
            "facts": [Qspmpluginmanagerv3EntityNewSchema.from_dict(_item) for _item in obj["facts"]] if obj.get("facts") is not None else None,
            "org_id": obj.get("org_id"),
            "plugin_id": obj.get("plugin_id"),
            "run_for_all_scans": obj.get("run_for_all_scans"),
            "scan_desc": obj.get("scan_desc"),
            "scan_id": obj.get("scan_id"),
            "user_email": obj.get("user_email"),
            "validation_result": Qspmpluginmanagerv3ValidationResult.from_dict(obj["validation_result"]) if obj.get("validation_result") is not None else None
        })
        return _obj


