# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_display_header import Reportsv3DisplayHeader
from typing import Optional, Set
from typing_extensions import Self

class Reportsv3ChartDisplayLayout(BaseModel):
    """
    ChartDisplayLayout has Chart matadata , rows and headers.
    """ # noqa: E501
    chart_headers: Optional[List[Reportsv3DisplayHeader]] = Field(default=None, description="The Chart headers.")
    chart_id: Optional[StrictStr] = Field(default=None, description="The chart ID.")
    report_id: Optional[StrictStr] = Field(default=None, description="The report ID.")
    results_limit: Optional[StrictInt] = Field(default=None, description="Chart data results limit.")
    __properties: ClassVar[List[str]] = ["chart_headers", "chart_id", "report_id", "results_limit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Reportsv3ChartDisplayLayout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in chart_headers (list)
        _items = []
        if self.chart_headers:
            for _item in self.chart_headers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['chart_headers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Reportsv3ChartDisplayLayout from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chart_headers": [Reportsv3DisplayHeader.from_dict(_item) for _item in obj["chart_headers"]] if obj.get("chart_headers") is not None else None,
            "chart_id": obj.get("chart_id"),
            "report_id": obj.get("report_id"),
            "results_limit": obj.get("results_limit")
        })
        return _obj


