# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_date_range_type import Reportsv3DateRangeType
from ibm_gdsc_sdk_software.models.reportsv3_date_range_unit import Reportsv3DateRangeUnit
from typing import Optional, Set
from typing_extensions import Self

class Reportsv3DateRange(BaseModel):
    """
    DateRange represents a date range type - from an enum and if its custom / relative - the start and the end date.
    """ # noqa: E501
    end_date: Optional[StrictStr] = Field(default=None, description="If custom holds the date string.")
    end_number: Optional[StrictInt] = Field(default=None, description="If custom-relative -  holds the end number.")
    end_unit: Optional[Reportsv3DateRangeUnit] = None
    start_date: Optional[StrictStr] = Field(default=None, description="If custom holds the date string.")
    start_number: Optional[StrictInt] = Field(default=None, description="If custom-relative -  holds the start number.")
    start_unit: Optional[Reportsv3DateRangeUnit] = None
    type: Optional[Reportsv3DateRangeType] = None
    __properties: ClassVar[List[str]] = ["end_date", "end_number", "end_unit", "start_date", "start_number", "start_unit", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Reportsv3DateRange from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Reportsv3DateRange from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "end_date": obj.get("end_date"),
            "end_number": obj.get("end_number"),
            "end_unit": obj.get("end_unit"),
            "start_date": obj.get("start_date"),
            "start_number": obj.get("start_number"),
            "start_unit": obj.get("start_unit"),
            "type": obj.get("type")
        })
        return _obj


