# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_option_type import Reportsv3OptionType
from ibm_gdsc_sdk_software.models.reportsv3_report_agg_filter import Reportsv3ReportAggFilter
from typing import Optional, Set
from typing_extensions import Self

class Reportsv3ReportFilterBrackets(BaseModel):
    """
    ReportFilterBrackets represents a report filter bracket.
    """ # noqa: E501
    brackets_id: Optional[StrictInt] = Field(default=None, description="Brackets ID.")
    filter_name: Optional[StrictStr] = Field(default=None, description="Optional: Allow for naming of custom filters.")
    filters_array: Optional[List[Reportsv3ReportFilter]] = Field(default=None, description="Filters Array.")
    having_array: Optional[List[Reportsv3ReportAggFilter]] = None
    is_custom: Optional[StrictBool] = Field(default=None, description="Optional: Indicate if this is a custom filter in the UI.")
    option_type: Optional[Reportsv3OptionType] = None
    sequence: Optional[StrictInt] = Field(default=None, description="Filter sequence.")
    __properties: ClassVar[List[str]] = ["brackets_id", "filter_name", "filters_array", "having_array", "is_custom", "option_type", "sequence"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Reportsv3ReportFilterBrackets from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in filters_array (list)
        _items = []
        if self.filters_array:
            for _item in self.filters_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['filters_array'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in having_array (list)
        _items = []
        if self.having_array:
            for _item in self.having_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['having_array'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Reportsv3ReportFilterBrackets from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "brackets_id": obj.get("brackets_id"),
            "filter_name": obj.get("filter_name"),
            "filters_array": [Reportsv3ReportFilter.from_dict(_item) for _item in obj["filters_array"]] if obj.get("filters_array") is not None else None,
            "having_array": [Reportsv3ReportAggFilter.from_dict(_item) for _item in obj["having_array"]] if obj.get("having_array") is not None else None,
            "is_custom": obj.get("is_custom"),
            "option_type": obj.get("option_type"),
            "sequence": obj.get("sequence")
        })
        return _obj

from ibm_gdsc_sdk_software.models.reportsv3_report_filter import Reportsv3ReportFilter
# TODO: Rewrite to not use raise_errors
Reportsv3ReportFilterBrackets.model_rebuild(raise_errors=False)

