# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_contribution_pointers_info_object import Reportsv3ContributionPointersInfoObject
from typing import Optional, Set
from typing_extensions import Self

class Reportsv3TransposeRequest(BaseModel):
    """
    TransposeRequest is the request type for the api call to get the SQls based on the constructIDs.
    """ # noqa: E501
    construct_ids: Optional[List[StrictStr]] = Field(default=None, description="The list of construct IDs to get the SQLs for.")
    contribution_indicators: Optional[StrictStr] = Field(default=None, description="The contribution indicators represented as a string.")
    contribution_pointers: Optional[List[Reportsv3ContributionPointersInfoObject]] = Field(default=None, description="The list of contribution pointers.")
    limit: Optional[StrictStr] = Field(default=None, description="The max amount of rows to return for pagination. Required if report query uses offset and limit parameters.")
    offset: Optional[StrictStr] = Field(default=None, description="The amount to offset the rows by for pagination. Required if report query uses offset and limit parameters.")
    summary: Optional[StrictBool] = Field(default=None, description="Whether or not to run Summary query.")
    __properties: ClassVar[List[str]] = ["construct_ids", "contribution_indicators", "contribution_pointers", "limit", "offset", "summary"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Reportsv3TransposeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in contribution_pointers (list)
        _items = []
        if self.contribution_pointers:
            for _item in self.contribution_pointers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['contribution_pointers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Reportsv3TransposeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "construct_ids": obj.get("construct_ids"),
            "contribution_indicators": obj.get("contribution_indicators"),
            "contribution_pointers": [Reportsv3ContributionPointersInfoObject.from_dict(_item) for _item in obj["contribution_pointers"]] if obj.get("contribution_pointers") is not None else None,
            "limit": obj.get("limit"),
            "offset": obj.get("offset"),
            "summary": obj.get("summary")
        })
        return _obj


