# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_chart_settingsv2 import Reportsv3ChartSettingsv2
from typing import Optional, Set
from typing_extensions import Self

class Reportsv3UpdateChartv2Request(BaseModel):
    """
    UpdateChartv2Request is the argument type used to update a VEGA chart.
    """ # noqa: E501
    chart_id: Optional[StrictStr] = Field(default=None, description="Unique chart ID.")
    chart_settings_v2: Optional[Reportsv3ChartSettingsv2] = None
    primary_category: Optional[StrictInt] = None
    primary_measure: Optional[StrictInt] = None
    secondary_category: Optional[StrictInt] = None
    secondary_measure: Optional[StrictInt] = None
    tertiary_category: Optional[StrictInt] = None
    tertiary_measure: Optional[StrictInt] = None
    vega_definition: Optional[StrictStr] = Field(default=None, description="The VEGA chart definition in a stringified JSON.")
    __properties: ClassVar[List[str]] = ["chart_id", "chart_settings_v2", "primary_category", "primary_measure", "secondary_category", "secondary_measure", "tertiary_category", "tertiary_measure", "vega_definition"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Reportsv3UpdateChartv2Request from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of chart_settings_v2
        if self.chart_settings_v2:
            _dict['chart_settings_v2'] = self.chart_settings_v2.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Reportsv3UpdateChartv2Request from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chart_id": obj.get("chart_id"),
            "chart_settings_v2": Reportsv3ChartSettingsv2.from_dict(obj["chart_settings_v2"]) if obj.get("chart_settings_v2") is not None else None,
            "primary_category": obj.get("primary_category"),
            "primary_measure": obj.get("primary_measure"),
            "secondary_category": obj.get("secondary_category"),
            "secondary_measure": obj.get("secondary_measure"),
            "tertiary_category": obj.get("tertiary_category"),
            "tertiary_measure": obj.get("tertiary_measure"),
            "vega_definition": obj.get("vega_definition")
        })
        return _obj


