# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_variant_rule import Reportsv3VariantRule
from typing import Optional, Set
from typing_extensions import Self

class Reportsv3VariantDetails(BaseModel):
    """
    Reportsv3VariantDetails
    """ # noqa: E501
    header_id: Optional[StrictStr] = None
    last_run: Optional[datetime] = None
    last_run_error: Optional[StrictStr] = None
    rules: Optional[List[Reportsv3VariantRule]] = None
    total_count: Optional[StrictInt] = None
    variant_id: Optional[StrictStr] = None
    variant_name: Optional[StrictStr] = None
    variant_table: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["header_id", "last_run", "last_run_error", "rules", "total_count", "variant_id", "variant_name", "variant_table"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Reportsv3VariantDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rules (list)
        _items = []
        if self.rules:
            for _item in self.rules:
                if _item:
                    _items.append(_item.to_dict())
            _dict['rules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Reportsv3VariantDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "header_id": obj.get("header_id"),
            "last_run": obj.get("last_run"),
            "last_run_error": obj.get("last_run_error"),
            "rules": [Reportsv3VariantRule.from_dict(_item) for _item in obj["rules"]] if obj.get("rules") is not None else None,
            "total_count": obj.get("total_count"),
            "variant_id": obj.get("variant_id"),
            "variant_name": obj.get("variant_name"),
            "variant_table": obj.get("variant_table")
        })
        return _obj


