# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Riskanalyticscontrollerv3EmergingRiskDetails(BaseModel):
    """
    EmergingRiskDetails is the information for emerging risks.
    """ # noqa: E501
    end_max_time: Optional[datetime] = Field(default=None, description="Time of the last max value.")
    end_max_value: Optional[StrictInt] = Field(default=None, description="Value of the last max value.")
    peak_max_time: Optional[datetime] = Field(default=None, description="Time of the peak max value.")
    peak_max_value: Optional[StrictInt] = Field(default=None, description="Value of the peak max value.")
    previous_max_value: Optional[StrictInt] = Field(default=None, description="Value of the previous max value.")
    risk_features: Optional[StrictStr] = Field(default=None, description="Features of the risk in JSON format.")
    start_max_time: Optional[datetime] = Field(default=None, description="Time of the first max value.")
    start_max_value: Optional[StrictInt] = Field(default=None, description="Value of the first max value.")
    __properties: ClassVar[List[str]] = ["end_max_time", "end_max_value", "peak_max_time", "peak_max_value", "previous_max_value", "risk_features", "start_max_time", "start_max_value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3EmergingRiskDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3EmergingRiskDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "end_max_time": obj.get("end_max_time"),
            "end_max_value": obj.get("end_max_value"),
            "peak_max_time": obj.get("peak_max_time"),
            "peak_max_value": obj.get("peak_max_value"),
            "previous_max_value": obj.get("previous_max_value"),
            "risk_features": obj.get("risk_features"),
            "start_max_time": obj.get("start_max_time"),
            "start_max_value": obj.get("start_max_value")
        })
        return _obj


