# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.riskanalyticscontrollerv3_finding_details_map import Riskanalyticscontrollerv3FindingDetailsMap
from ibm_gdsc_sdk_software.models.riskanalyticscontrollerv3_observation_type import Riskanalyticscontrollerv3ObservationType
from typing import Optional, Set
from typing_extensions import Self

class Riskanalyticscontrollerv3Finding(BaseModel):
    """
    Riskanalyticscontrollerv3Finding
    """ # noqa: E501
    finding_description: Optional[StrictStr] = Field(default=None, description="Finding description.")
    finding_details_map: Optional[List[Riskanalyticscontrollerv3FindingDetailsMap]] = Field(default=None, description="Finding details - Optional.")
    finding_type: Optional[Riskanalyticscontrollerv3ObservationType] = None
    __properties: ClassVar[List[str]] = ["finding_description", "finding_details_map", "finding_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3Finding from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in finding_details_map (list)
        _items = []
        if self.finding_details_map:
            for _item in self.finding_details_map:
                if _item:
                    _items.append(_item.to_dict())
            _dict['finding_details_map'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3Finding from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "finding_description": obj.get("finding_description"),
            "finding_details_map": [Riskanalyticscontrollerv3FindingDetailsMap.from_dict(_item) for _item in obj["finding_details_map"]] if obj.get("finding_details_map") is not None else None,
            "finding_type": obj.get("finding_type")
        })
        return _obj


