# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.riskanalyticscontrollerv3_emerging_risk_details import Riskanalyticscontrollerv3EmergingRiskDetails
from ibm_gdsc_sdk_software.models.riskanalyticscontrollerv3_observation import Riskanalyticscontrollerv3Observation
from ibm_gdsc_sdk_software.models.riskanalyticscontrollerv3_risk_event import Riskanalyticscontrollerv3RiskEvent
from typing import Optional, Set
from typing_extensions import Self

class Riskanalyticscontrollerv3GetRiskEventDetailsResponse(BaseModel):
    """
    GetRiskEventDetailsResponse is the response object for GetRiskEventDetails API.
    """ # noqa: E501
    emerging_risk_details: Optional[Riskanalyticscontrollerv3EmergingRiskDetails] = None
    observations: Optional[List[Riskanalyticscontrollerv3Observation]] = Field(default=None, description="Observations list.")
    risk_event: Optional[Riskanalyticscontrollerv3RiskEvent] = None
    __properties: ClassVar[List[str]] = ["emerging_risk_details", "observations", "risk_event"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3GetRiskEventDetailsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of emerging_risk_details
        if self.emerging_risk_details:
            _dict['emerging_risk_details'] = self.emerging_risk_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in observations (list)
        _items = []
        if self.observations:
            for _item in self.observations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['observations'] = _items
        # override the default output from pydantic by calling `to_dict()` of risk_event
        if self.risk_event:
            _dict['risk_event'] = self.risk_event.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3GetRiskEventDetailsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "emerging_risk_details": Riskanalyticscontrollerv3EmergingRiskDetails.from_dict(obj["emerging_risk_details"]) if obj.get("emerging_risk_details") is not None else None,
            "observations": [Riskanalyticscontrollerv3Observation.from_dict(_item) for _item in obj["observations"]] if obj.get("observations") is not None else None,
            "risk_event": Riskanalyticscontrollerv3RiskEvent.from_dict(obj["risk_event"]) if obj.get("risk_event") is not None else None
        })
        return _obj


