# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.riskanalyticsenginev3_pivot_type import Riskanalyticsenginev3PivotType
from ibm_gdsc_sdk_software.models.riskanalyticsenginev3_risk import Riskanalyticsenginev3Risk
from typing import Optional, Set
from typing_extensions import Self

class Riskanalyticsenginev3GenerateLeadsResponse(BaseModel):
    """
    GenerateLeadsResponse is the response object for GenerateLeads API.
    """ # noqa: E501
    end_time: Optional[datetime] = Field(default=None, description="The end time of the risks in format YYYY-MM-ddTHH:mm:ssZ.")
    pivot_type: Optional[Riskanalyticsenginev3PivotType] = None
    risks: Optional[List[Riskanalyticsenginev3Risk]] = Field(default=None, description="Returns an array with risks with pivot and leads.")
    start_time: Optional[datetime] = Field(default=None, description="The start time of the risks in format YYYY-MM-ddTHH:mm:ssZ.")
    __properties: ClassVar[List[str]] = ["end_time", "pivot_type", "risks", "start_time"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Riskanalyticsenginev3GenerateLeadsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in risks (list)
        _items = []
        if self.risks:
            for _item in self.risks:
                if _item:
                    _items.append(_item.to_dict())
            _dict['risks'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Riskanalyticsenginev3GenerateLeadsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "end_time": obj.get("end_time"),
            "pivot_type": obj.get("pivot_type"),
            "risks": [Riskanalyticsenginev3Risk.from_dict(_item) for _item in obj["risks"]] if obj.get("risks") is not None else None,
            "start_time": obj.get("start_time")
        })
        return _obj


