# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.reportsv3_run_time_parameter import Reportsv3RunTimeParameter
from typing import Optional, Set
from typing_extensions import Self

class Schedulerv3ReportParameter(BaseModel):
    """
    ReportParameter includes all the parameters needed to run a report.
    """ # noqa: E501
    extra_detail: Optional[StrictStr] = None
    report_id: Optional[StrictStr] = Field(default=None, description="Report ID for the scheduled report.")
    report_name: Optional[StrictStr] = Field(default=None, description="Optional: Report Name for the scheduled report.")
    runtime_parameters: Optional[List[Reportsv3RunTimeParameter]] = Field(default=None, description="Optional: Runtime parameters for this report.")
    sync_execution_date: Optional[StrictBool] = Field(default=None, description="Optional: Flag if sync query_from_date when running this report.")
    __properties: ClassVar[List[str]] = ["extra_detail", "report_id", "report_name", "runtime_parameters", "sync_execution_date"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Schedulerv3ReportParameter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in runtime_parameters (list)
        _items = []
        if self.runtime_parameters:
            for _item in self.runtime_parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['runtime_parameters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Schedulerv3ReportParameter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "extra_detail": obj.get("extra_detail"),
            "report_id": obj.get("report_id"),
            "report_name": obj.get("report_name"),
            "runtime_parameters": [Reportsv3RunTimeParameter.from_dict(_item) for _item in obj["runtime_parameters"]] if obj.get("runtime_parameters") is not None else None,
            "sync_execution_date": obj.get("sync_execution_date")
        })
        return _obj


