# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.schedulerv3_execution_status import Schedulerv3ExecutionStatus
from typing import Optional, Set
from typing_extensions import Self

class Schedulerv3ScheduledJobsFilter(BaseModel):
    """
    ScheduledJobsFilter includes all fields used to filter the set of desired scheduled jobs returned.
    """ # noqa: E501
    enabled: Optional[StrictStr] = Field(default=None, description="Optional: Enabled or not.")
    end_time: Optional[datetime] = Field(default=None, description="Optional: Return records ending time.")
    ignore_acl: Optional[StrictBool] = None
    name_filter: Optional[List[StrictStr]] = Field(default=None, description="Optional: Filter by report name.")
    start_time: Optional[datetime] = Field(default=None, description="Optional: Return records starting at this time (>=).")
    status_filter: Optional[List[Schedulerv3ExecutionStatus]] = Field(default=None, description="Optional: Filter by status.")
    tag_filter: Optional[StrictStr] = Field(default=None, description="Optional: Filter by tags.")
    __properties: ClassVar[List[str]] = ["enabled", "end_time", "ignore_acl", "name_filter", "start_time", "status_filter", "tag_filter"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Schedulerv3ScheduledJobsFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Schedulerv3ScheduledJobsFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enabled": obj.get("enabled"),
            "end_time": obj.get("end_time"),
            "ignore_acl": obj.get("ignore_acl"),
            "name_filter": obj.get("name_filter"),
            "start_time": obj.get("start_time"),
            "status_filter": obj.get("status_filter"),
            "tag_filter": obj.get("tag_filter")
        })
        return _obj


