# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.schedulerv3_integration_parameter import Schedulerv3IntegrationParameter
from ibm_gdsc_sdk_software.models.schedulerv3_report_parameter import Schedulerv3ReportParameter
from typing import Optional, Set
from typing_extensions import Self

class Schedulerv3TaskParameter(BaseModel):
    """
    TaskParameter includes all the parameters needed to run a job, add different job runtime parameters here.
    """ # noqa: E501
    data_import_parameter: Optional[Schedulerv3IntegrationParameter] = None
    report_parameter: Optional[Schedulerv3ReportParameter] = None
    __properties: ClassVar[List[str]] = ["data_import_parameter", "report_parameter"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Schedulerv3TaskParameter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data_import_parameter
        if self.data_import_parameter:
            _dict['data_import_parameter'] = self.data_import_parameter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of report_parameter
        if self.report_parameter:
            _dict['report_parameter'] = self.report_parameter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Schedulerv3TaskParameter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "data_import_parameter": Schedulerv3IntegrationParameter.from_dict(obj["data_import_parameter"]) if obj.get("data_import_parameter") is not None else None,
            "report_parameter": Schedulerv3ReportParameter.from_dict(obj["report_parameter"]) if obj.get("report_parameter") is not None else None
        })
        return _obj


