# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.schedulerv3_create_scheduled_job_request import Schedulerv3CreateScheduledJobRequest
from typing import Optional, Set
from typing_extensions import Self

class Schedulerv3UpdateScheduledJobRequest(BaseModel):
    """
    UpdateScheduledJobRequest message for Put v3/schedules/ api.  The both fields are required, all other fields are optional.
    """ # noqa: E501
    query: Optional[Dict[str, StrictStr]] = Field(default=None, description="Optional: Update field name and value.")
    schedule_id: Optional[StrictStr] = Field(default=None, description="Unique ID, required for update.")
    scheduled_job: Optional[Schedulerv3CreateScheduledJobRequest] = None
    __properties: ClassVar[List[str]] = ["query", "schedule_id", "scheduled_job"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Schedulerv3UpdateScheduledJobRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of scheduled_job
        if self.scheduled_job:
            _dict['scheduled_job'] = self.scheduled_job.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Schedulerv3UpdateScheduledJobRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "query": obj.get("query"),
            "schedule_id": obj.get("schedule_id"),
            "scheduled_job": Schedulerv3CreateScheduledJobRequest.from_dict(obj["scheduled_job"]) if obj.get("scheduled_job") is not None else None
        })
        return _obj


