# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.templatesv3_integration import Templatesv3Integration
from ibm_gdsc_sdk_software.models.templatesv3_mime_type import Templatesv3MIMEType
from ibm_gdsc_sdk_software.models.templatesv3_origin import Templatesv3Origin
from typing import Optional, Set
from typing_extensions import Self

class Templatesv3TransformTemplateRequest(BaseModel):
    """
    Transforms a template into a fully resolved version with data substitution.  The template is defined by the specified  template id or is dynamically located base on the supplied Integration, Origin and MIMEType.  The data supplied  must match the substitution fields associated with the evaluated template.
    """ # noqa: E501
    data: Optional[Dict[str, StrictStr]] = Field(default=None, description="Data used to transform the template.")
    integration: Optional[Templatesv3Integration] = None
    mime_type: Optional[Templatesv3MIMEType] = None
    origin: Optional[Templatesv3Origin] = None
    template_id: Optional[StrictStr] = Field(default=None, description="The ID of the template to be transformed.")
    __properties: ClassVar[List[str]] = ["data", "integration", "mime_type", "origin", "template_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Templatesv3TransformTemplateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Templatesv3TransformTemplateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "data": obj.get("data"),
            "integration": obj.get("integration"),
            "mime_type": obj.get("mime_type"),
            "origin": obj.get("origin"),
            "template_id": obj.get("template_id")
        })
        return _obj


