# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.tenantuserv3_tenant_capability_part_numbers import Tenantuserv3TenantCapabilityPartNumbers
from typing import Optional, Set
from typing_extensions import Self

class Tenantuserv3GetTenantPartNumbersDiffResponse(BaseModel):
    """
    GetTenantPartNumbersDiffResponse message for Get v3/tenants api.
    """ # noqa: E501
    are_part_numbers_same: Optional[StrictBool] = None
    tenant_capability_part_numbers_changes: Optional[Dict[str, Tenantuserv3TenantCapabilityPartNumbers]] = None
    __properties: ClassVar[List[str]] = ["are_part_numbers_same", "tenant_capability_part_numbers_changes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Tenantuserv3GetTenantPartNumbersDiffResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in tenant_capability_part_numbers_changes (dict)
        _field_dict = {}
        if self.tenant_capability_part_numbers_changes:
            for _key in self.tenant_capability_part_numbers_changes:
                if self.tenant_capability_part_numbers_changes[_key]:
                    _field_dict[_key] = self.tenant_capability_part_numbers_changes[_key].to_dict()
            _dict['tenant_capability_part_numbers_changes'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Tenantuserv3GetTenantPartNumbersDiffResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "are_part_numbers_same": obj.get("are_part_numbers_same"),
            "tenant_capability_part_numbers_changes": dict(
                (_k, Tenantuserv3TenantCapabilityPartNumbers.from_dict(_v))
                for _k, _v in obj["tenant_capability_part_numbers_changes"].items()
            )
            if obj.get("tenant_capability_part_numbers_changes") is not None
            else None
        })
        return _obj


