# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Tenantuserv3Privilege(BaseModel):
    """
    Tenantuserv3Privilege
    """ # noqa: E501
    author_id: Optional[StrictStr] = Field(default=None, description="Privilege author's id.")
    immutable_roles: Optional[List[StrictStr]] = Field(default=None, description="Roles of the type:* permission.")
    manage_roles: Optional[List[StrictStr]] = Field(default=None, description="Roles of the management permission.")
    name: Optional[StrictStr] = Field(default=None, description="A privilege name that the access-manager sees (for pre-defined privileges, use translation text).")
    nls_id: Optional[StrictStr] = None
    privilege_id: Optional[StrictStr] = Field(default=None, description="Permanent id of the privilege.")
    removable: Optional[StrictBool] = Field(default=None, description="All pre-defined privileges are not removable.")
    roles: Optional[List[StrictStr]] = Field(default=None, description="The array of Insights roles that this privilege belongs to.")
    type: Optional[StrictStr] = Field(default=None, description="Type of privilege: report, classification, group, page, restapi, etc.")
    __properties: ClassVar[List[str]] = ["author_id", "immutable_roles", "manage_roles", "name", "nls_id", "privilege_id", "removable", "roles", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Tenantuserv3Privilege from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Tenantuserv3Privilege from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "author_id": obj.get("author_id"),
            "immutable_roles": obj.get("immutable_roles"),
            "manage_roles": obj.get("manage_roles"),
            "name": obj.get("name"),
            "nls_id": obj.get("nls_id"),
            "privilege_id": obj.get("privilege_id"),
            "removable": obj.get("removable"),
            "roles": obj.get("roles"),
            "type": obj.get("type")
        })
        return _obj


