# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Universalconnectormanagerv3DatasourceDefinition(BaseModel):
    """
    Datasource Definition encapsulates all data necessary for a handling datasource in Universal Connector.
    """ # noqa: E501
    datasource_filter: Optional[StrictStr] = Field(default=None, description="Datasource configuration filter section text.")
    datasource_id: Optional[StrictStr] = Field(default=None, description="The datasource ID.")
    datasource_input: Optional[StrictStr] = Field(default=None, description="Datasource configuration input section text.")
    datasource_name: Optional[StrictStr] = Field(default=None, description="Datasource name.")
    owner_user_id: Optional[StrictStr] = Field(default=None, description="The name of the user created datasource.")
    update_time: Optional[datetime] = Field(default=None, description="The datasource update time.")
    __properties: ClassVar[List[str]] = ["datasource_filter", "datasource_id", "datasource_input", "datasource_name", "owner_user_id", "update_time"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Universalconnectormanagerv3DatasourceDefinition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Universalconnectormanagerv3DatasourceDefinition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "datasource_filter": obj.get("datasource_filter"),
            "datasource_id": obj.get("datasource_id"),
            "datasource_input": obj.get("datasource_input"),
            "datasource_name": obj.get("datasource_name"),
            "owner_user_id": obj.get("owner_user_id"),
            "update_time": obj.get("update_time")
        })
        return _obj


