# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.universalconnectormanagerv3_datasource_type import Universalconnectormanagerv3DatasourceType
from typing import Optional, Set
from typing_extensions import Self

class Universalconnectormanagerv3PluginDefinition(BaseModel):
    """
    Plugin definition based on UCPluginDefinition.
    """ # noqa: E501
    plugin_alias: Optional[StrictStr] = Field(default=None, description="mongoDB.")
    plugin_configuration_notes: Optional[StrictStr] = Field(default=None, description="Config noted.")
    plugin_description: Optional[StrictStr] = Field(default=None, description="Description.")
    plugin_developer: Optional[StrictStr] = Field(default=None, description="Developer.")
    plugin_documentation_path: Optional[StrictStr] = Field(default=None, description="Documentation path.")
    plugin_license: Optional[StrictStr] = Field(default=None, description="License.")
    plugin_name: Optional[StrictStr] = Field(default=None, description="Name.")
    plugin_pipeline_type: Optional[StrictStr] = Field(default=None, description="Pipeline type.")
    plugin_type: Optional[StrictStr] = Field(default=None, description="Filter/input.")
    plugin_version: Optional[StrictStr] = Field(default=None, description="Plugin version.")
    supported_input_plugins: Optional[List[StrictStr]] = Field(default=None, description="Collection of supported input plugins.", alias="supportedInputPlugins")
    supported_datasources: Optional[List[Universalconnectormanagerv3DatasourceType]] = Field(default=None, description="Collection of DatasourceType.")
    upload_date: Optional[datetime] = Field(default=None, description="Datetime of plugin upload.")
    upload_user: Optional[StrictStr] = Field(default=None, description="Plugin user upload.")
    __properties: ClassVar[List[str]] = ["plugin_alias", "plugin_configuration_notes", "plugin_description", "plugin_developer", "plugin_documentation_path", "plugin_license", "plugin_name", "plugin_pipeline_type", "plugin_type", "plugin_version", "supportedInputPlugins", "supported_datasources", "upload_date", "upload_user"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Universalconnectormanagerv3PluginDefinition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in supported_datasources (list)
        _items = []
        if self.supported_datasources:
            for _item in self.supported_datasources:
                if _item:
                    _items.append(_item.to_dict())
            _dict['supported_datasources'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Universalconnectormanagerv3PluginDefinition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "plugin_alias": obj.get("plugin_alias"),
            "plugin_configuration_notes": obj.get("plugin_configuration_notes"),
            "plugin_description": obj.get("plugin_description"),
            "plugin_developer": obj.get("plugin_developer"),
            "plugin_documentation_path": obj.get("plugin_documentation_path"),
            "plugin_license": obj.get("plugin_license"),
            "plugin_name": obj.get("plugin_name"),
            "plugin_pipeline_type": obj.get("plugin_pipeline_type"),
            "plugin_type": obj.get("plugin_type"),
            "plugin_version": obj.get("plugin_version"),
            "supportedInputPlugins": obj.get("supportedInputPlugins"),
            "supported_datasources": [Universalconnectormanagerv3DatasourceType.from_dict(_item) for _item in obj["supported_datasources"]] if obj.get("supported_datasources") is not None else None,
            "upload_date": obj.get("upload_date"),
            "upload_user": obj.get("upload_user")
        })
        return _obj


