# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from ibm_gdsc_sdk_software.models.access_type import AccessType
from ibm_gdsc_sdk_software.models.user_sensitive_categories_sensitive_categories_inner import UserSensitiveCategoriesSensitiveCategoriesInner
from typing import Optional, Set
from typing_extensions import Self

class UserSensitiveCategories200Response(BaseModel):
    """
    UserSensitiveCategories200Response
    """ # noqa: E501
    id: StrictStr
    name: StrictStr
    type: StrictStr
    permissions: List[AccessType]
    account_ids: List[StrictStr] = Field(alias="accountIds")
    sensitive_categories: List[UserSensitiveCategoriesSensitiveCategoriesInner] = Field(alias="sensitiveCategories")
    accessible_permission_configurations: Union[StrictFloat, StrictInt] = Field(alias="accessiblePermissionConfigurations")
    __properties: ClassVar[List[str]] = ["id", "name", "type", "permissions", "accountIds", "sensitiveCategories", "accessiblePermissionConfigurations"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserSensitiveCategories200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in sensitive_categories (list)
        _items = []
        if self.sensitive_categories:
            for _item in self.sensitive_categories:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sensitiveCategories'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserSensitiveCategories200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "type": obj.get("type"),
            "permissions": obj.get("permissions"),
            "accountIds": obj.get("accountIds"),
            "sensitiveCategories": [UserSensitiveCategoriesSensitiveCategoriesInner.from_dict(_item) for _item in obj["sensitiveCategories"]] if obj.get("sensitiveCategories") is not None else None,
            "accessiblePermissionConfigurations": obj.get("accessiblePermissionConfigurations")
        })
        return _obj


