# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.workflowv3_comment import Workflowv3Comment
from ibm_gdsc_sdk_software.models.workflowv3_entity import Workflowv3Entity
from ibm_gdsc_sdk_software.models.workflowv3_origin import Workflowv3Origin
from ibm_gdsc_sdk_software.models.workflowv3_priority import Workflowv3Priority
from ibm_gdsc_sdk_software.models.workflowv3_status import Workflowv3Status
from ibm_gdsc_sdk_software.models.workflowv3_task import Workflowv3Task
from typing import Optional, Set
from typing_extensions import Self

class Workflowv3Case(BaseModel):
    """
    Top-level task (case).
    """ # noqa: E501
    alt_id: Optional[StrictStr] = Field(default=None, description="Alternate Unique ID.")
    artifacts: Optional[List[StrictStr]] = Field(default=None, description="Array of artifact URLs, i.e. a URL to a report result.")
    assignments: Optional[List[Workflowv3Entity]] = Field(default=None, description="Entities that the case is assigned to.")
    case_id: Optional[StrictStr] = Field(default=None, description="Unique ID.")
    comments: Optional[List[Workflowv3Comment]] = Field(default=None, description="Comments - who, when, what.")
    date_created: Optional[datetime] = Field(default=None, description="Date created (Scheduled job queue time).")
    date_due: Optional[datetime] = Field(default=None, description="Date due (Scheduled job next run).")
    date_modified: Optional[datetime] = Field(default=None, description="Date of last update.")
    description: Optional[StrictStr] = Field(default=None, description="Multiline description of the case.")
    full_access: Optional[StrictBool] = Field(default=None, description="Access level.")
    origin: Optional[Workflowv3Origin] = None
    priority: Optional[Workflowv3Priority] = None
    status: Optional[Workflowv3Status] = None
    tasks: Optional[List[Workflowv3Task]] = Field(default=None, description="Sub-tasks that the current user has access to.")
    title: Optional[StrictStr] = Field(default=None, description="Case title (subject).")
    __properties: ClassVar[List[str]] = ["alt_id", "artifacts", "assignments", "case_id", "comments", "date_created", "date_due", "date_modified", "description", "full_access", "origin", "priority", "status", "tasks", "title"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Workflowv3Case from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in assignments (list)
        _items = []
        if self.assignments:
            for _item in self.assignments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['assignments'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in comments (list)
        _items = []
        if self.comments:
            for _item in self.comments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['comments'] = _items
        # override the default output from pydantic by calling `to_dict()` of origin
        if self.origin:
            _dict['origin'] = self.origin.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in tasks (list)
        _items = []
        if self.tasks:
            for _item in self.tasks:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tasks'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Workflowv3Case from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alt_id": obj.get("alt_id"),
            "artifacts": obj.get("artifacts"),
            "assignments": [Workflowv3Entity.from_dict(_item) for _item in obj["assignments"]] if obj.get("assignments") is not None else None,
            "case_id": obj.get("case_id"),
            "comments": [Workflowv3Comment.from_dict(_item) for _item in obj["comments"]] if obj.get("comments") is not None else None,
            "date_created": obj.get("date_created"),
            "date_due": obj.get("date_due"),
            "date_modified": obj.get("date_modified"),
            "description": obj.get("description"),
            "full_access": obj.get("full_access"),
            "origin": Workflowv3Origin.from_dict(obj["origin"]) if obj.get("origin") is not None else None,
            "priority": obj.get("priority"),
            "status": obj.get("status"),
            "tasks": [Workflowv3Task.from_dict(_item) for _item in obj["tasks"]] if obj.get("tasks") is not None else None,
            "title": obj.get("title")
        })
        return _obj


