# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_software.models.workflowv3_entity import Workflowv3Entity
from ibm_gdsc_sdk_software.models.workflowv3_priority import Workflowv3Priority
from ibm_gdsc_sdk_software.models.workflowv3_status import Workflowv3Status
from typing import Optional, Set
from typing_extensions import Self

class Workflowv3CaseEdit(BaseModel):
    """
    Workflowv3CaseEdit
    """ # noqa: E501
    artifacts: Optional[List[StrictStr]] = Field(default=None, description="Optional: Array of artifact URLs, i.e. a URL to a report result.")
    assignments: Optional[List[Workflowv3Entity]] = Field(default=None, description="Optional: Entities that the case is assigned to.")
    case_id: Optional[StrictStr] = Field(default=None, description="Unique ID - needed to update the case (read-only).")
    comment: Optional[StrictStr] = Field(default=None, description="Optional: Comment - this text will be added to the comments history.")
    date_due: Optional[datetime] = Field(default=None, description="Optional: Date due.")
    description: Optional[StrictStr] = Field(default=None, description="Optional: Multiline description of the case.")
    priority: Optional[Workflowv3Priority] = None
    status: Optional[Workflowv3Status] = None
    title: Optional[StrictStr] = Field(default=None, description="Optional: Case title (subject).")
    __properties: ClassVar[List[str]] = ["artifacts", "assignments", "case_id", "comment", "date_due", "description", "priority", "status", "title"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Workflowv3CaseEdit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in assignments (list)
        _items = []
        if self.assignments:
            for _item in self.assignments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['assignments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Workflowv3CaseEdit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "artifacts": obj.get("artifacts"),
            "assignments": [Workflowv3Entity.from_dict(_item) for _item in obj["assignments"]] if obj.get("assignments") is not None else None,
            "case_id": obj.get("case_id"),
            "comment": obj.get("comment"),
            "date_due": obj.get("date_due"),
            "description": obj.get("description"),
            "priority": obj.get("priority"),
            "status": obj.get("status"),
            "title": obj.get("title")
        })
        return _obj


