# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from ibm_gdsc_sdk_software.models.data_store import DataStore

class TestDataStore(unittest.TestCase):
    """DataStore unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> DataStore:
        """Test DataStore
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `DataStore`
        """
        model = DataStore()
        if include_optional:
            return DataStore(
                data_store_id = 'arn:aws:s3::123456789101:mys3-prod',
                data_store_type = 'ec2-instance',
                data_store_name = 'i-04ecec8c06b901234',
                cloud_account_details = ibm_gdsc_sdk_software.models.cloud_account_details.CloudAccountDetails(
                    cloud_account_id = '123456789101', 
                    cloud_account_name = 'corplex', 
                    service_provider = 'aws', ),
                cloud_region = 'eu-west-3',
                country = 'France',
                classification_status = 'CLASSIFIED',
                encryption_status = 'CLOUD_PROVIDER',
                custom_data = [
                    ibm_gdsc_sdk_software.models.string_key_value.StringKeyValue(
                        key = 'Component', 
                        value = 'Testing', )
                    ],
                label = 'test',
                data_custodian = 'Avi',
                cloud_tags = [
                    ibm_gdsc_sdk_software.models.string_key_value.StringKeyValue(
                        key = 'Component', 
                        value = 'Testing', )
                    ],
                is_backed_up = False,
                managed = True,
                vpc_id = 'arn:aws:ec2:eu-west-3:123456789101:vpc/vpc-8629fcee',
                stats = ibm_gdsc_sdk_software.models.data_store_stats.DataStoreStats(
                    resources_count = 102, 
                    app_flows_count = 3, 
                    config_flows_count = 63, 
                    sensitivities_count = 70, 
                    user_access_count = 1.337, 
                    sensitivities_summary = [
                        ibm_gdsc_sdk_software.models.sensitivity_summary.SensitivitySummary(
                            tag = 'BUSINESS_EMAIL_ADDRESS', 
                            count = 230, 
                            category = 'Personal', )
                        ], 
                    vulnerabilities_summary = [
                        ibm_gdsc_sdk_software.models.vulnerabilities_criticality_count_inner.VulnerabilitiesCriticalityCount_inner(
                            criticality = 'HIGH', 
                            count = 5, )
                        ], ),
                source = ibm_gdsc_sdk_software.models.data_store_source.DataStoreSource(
                    id = '151193111234', 
                    name = 'corplex', ),
                data_store_url = 'https://console.aws.amazon.com/ec2/v2/home?region=eu-west-3#InstanceDetails:instanceId=i-04abcd123456788',
                classification_error_message = '',
                last_classification_date = 1673216931271,
                unsupported_reason = ''
            )
        else:
            return DataStore(
                data_store_id = 'arn:aws:s3::123456789101:mys3-prod',
                data_store_type = 'ec2-instance',
                data_store_name = 'i-04ecec8c06b901234',
                cloud_account_details = ibm_gdsc_sdk_software.models.cloud_account_details.CloudAccountDetails(
                    cloud_account_id = '123456789101', 
                    cloud_account_name = 'corplex', 
                    service_provider = 'aws', ),
        )
        """

    def testDataStore(self):
        """Test DataStore"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
