# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from ibm_gdsc_sdk_software.models.vulnerabilities_summary_affected_data_store_summary_cloud_account_ids_count_inner import VulnerabilitiesSummaryAffectedDataStoreSummaryCloudAccountIdsCountInner
from ibm_gdsc_sdk_software.models.vulnerabilities_summary_affected_data_store_summary_cloud_regions_count_inner import VulnerabilitiesSummaryAffectedDataStoreSummaryCloudRegionsCountInner
from ibm_gdsc_sdk_software.models.vulnerabilities_summary_affected_data_store_summary_data_store_types_inner import VulnerabilitiesSummaryAffectedDataStoreSummaryDataStoreTypesInner
from typing import Optional, Set
from typing_extensions import Self

class VulnerabilitiesSummaryAffectedDataStoreSummary(BaseModel):
    """
    VulnerabilitiesSummaryAffectedDataStoreSummary
    """ # noqa: E501
    cloud_account_ids_count: List[VulnerabilitiesSummaryAffectedDataStoreSummaryCloudAccountIdsCountInner] = Field(alias="cloudAccountIdsCount")
    cloud_regions_count: List[VulnerabilitiesSummaryAffectedDataStoreSummaryCloudRegionsCountInner] = Field(alias="cloudRegionsCount")
    data_store_types: List[VulnerabilitiesSummaryAffectedDataStoreSummaryDataStoreTypesInner] = Field(alias="dataStoreTypes")
    __properties: ClassVar[List[str]] = ["cloudAccountIdsCount", "cloudRegionsCount", "dataStoreTypes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VulnerabilitiesSummaryAffectedDataStoreSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in cloud_account_ids_count (list)
        _items = []
        if self.cloud_account_ids_count:
            for _item in self.cloud_account_ids_count:
                if _item:
                    _items.append(_item.to_dict())
            _dict['cloudAccountIdsCount'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in cloud_regions_count (list)
        _items = []
        if self.cloud_regions_count:
            for _item in self.cloud_regions_count:
                if _item:
                    _items.append(_item.to_dict())
            _dict['cloudRegionsCount'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in data_store_types (list)
        _items = []
        if self.data_store_types:
            for _item in self.data_store_types:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dataStoreTypes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VulnerabilitiesSummaryAffectedDataStoreSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cloudAccountIdsCount": [VulnerabilitiesSummaryAffectedDataStoreSummaryCloudAccountIdsCountInner.from_dict(_item) for _item in obj["cloudAccountIdsCount"]] if obj.get("cloudAccountIdsCount") is not None else None,
            "cloudRegionsCount": [VulnerabilitiesSummaryAffectedDataStoreSummaryCloudRegionsCountInner.from_dict(_item) for _item in obj["cloudRegionsCount"]] if obj.get("cloudRegionsCount") is not None else None,
            "dataStoreTypes": [VulnerabilitiesSummaryAffectedDataStoreSummaryDataStoreTypesInner.from_dict(_item) for _item in obj["dataStoreTypes"]] if obj.get("dataStoreTypes") is not None else None
        })
        return _obj


